/*
**  WASABI-Hot! version 1.2c    (Sing unit)
**
**
**      -- copyright (c) 2001-2004 by Philips Japan, Ltd. -- All rights reserved --
**
**
**      ** This code has been made to check/learn                          ** 
**      **                             the ISP1362/ISP1363 functionalities **
**      ** Release 06-Aug-2004                                             **
**
**      OKANO, Akifumi
**      
**		Computing Segment, Semisonductors Div, Philips Japan Ltd.
**      akifumi.okano@philips.com
**      +81-3-3740-4668 
**
*/


//	Iso OUT to addrPtr->EP4

/****************************************************************************/
/*	includes																*/
/****************************************************************************/

#include		<stdio.h>
#include		<dos.h>
#include		<fcntl.h>
#include		<string.h>

#include		"_hc_core/dev_ep.h"
#include		"_hc_core/isr.h"
#include		"_hc_core/transfer.h"
#include		"_hc_hw/hc_comm.h"
#include		"_hc_hw/hw_acces.h"
//#include		"_hc_hw/dma.h"

#include		"_hc_cls/cls_hndl.h"

#include		"class_dr/audio/sing.h"

#include 		"_otg/otg_demo.h"

#include		"general.h"
#include		"ui.h"
#include		"griffin.h"

#define AUDIO_FROM_STORAGE

#ifdef AUDIO_FROM_STORAGE
#include		"class_dr/storage/fs_shell.h"
#include		"class_dr/storage/storage.h"
#endif

/****************************************************************************/
/*	constants																*/
/****************************************************************************/

#define		AUDIO_DEVICE_NAME_STR_LENGTH	45

#define		NUM_OF_AUDIO_COMMANDS			9

#define		BUFFER_DEPTH					32					//	this value must be power( 2, n )

#define		SING_BUFFER_EMPTY				0
#define		SING_BUFFER_FULL				BUFFER_DEPTH

#define		AUDIO_LEVEL_CHANGE_TIMELIMIT	20

#define		NO_AUDIO_DEVICE					1
#define		NO_AUDIO_FILE					2
#define		AUDIO_INITIALIZATION_FAIL		3

#ifdef USE_AUDIO_PEAK_METER

#define		DEFAULT_SCALING_LEVEL			14

#endif


/****************************************************************************/
/*	macros																	*/
/****************************************************************************/



/****************************************************************************/
/*	types																	*/
/****************************************************************************/

typedef short		iso_ptd_header;
typedef struct		ais
					{
						unsigned char		size;
						iso_ptd_header		*iso_header_ptr;
					}
					audio_index_size;

typedef struct		_audio_command_vct
					{
						unsigned char		com[ 10 ];
					}
					audio_command_vct;


/****************************************************************************/
/*	global vars																*/
/****************************************************************************/

char				g_audio_device_name[ AUDIO_DEVICE_NAME_STR_LENGTH + 3];

sing_file_info		gp_sing_file_strings[ MAX_NUM_OF_AUDIO_FILES ];						//	Music file list
char				gp_sing_list_file_str[ FILE_NAME_LENGTH ];							//	Music list file


audio_command_vct		g_audio_start_commands_codec[ NUM_OF_AUDIO_COMMANDS ]	= 			//	CODEC Audio device command before play
												{
													{ 0x01, 0x0B, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00 },					
													{ 0x01, 0x0B, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00 },	 
													{ 0x01, 0x0B, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00 },	
													{ 0x01, 0x0B, 0x01, 0x00, 0x02, 0x00, 0x00, 0x00 },	
													
													{ 0x21, 0x01, 0x01, 0x02, 0x00, 0x09, 0x02, 0x00, 0x00, 0x80 },			 
													{ 0x21, 0x01, 0x02, 0x02, 0x00, 0x09, 0x02, 0x00, 0x00, 0x80 },			
													
													{ 0x21, 0x01, 0x00, 0x03, 0x00, 0x0B, 0x01, 0x00, 0x00, },			 
													{ 0x21, 0x01, 0x00, 0x05, 0x00, 0x0B, 0x01, 0x00, 0x00, },			
													
													{ 0x01, 0x0B, 0x04, 0x00, 0x01, 0x00, 0x00, 0x00 }	
																					
													};



audio_command_vct		g_audio_start_commands_dac[ NUM_OF_AUDIO_COMMANDS ]	= 			//	 DAC Audio device command before play
												{
													{ 0x01, 0x0B, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },					//(21) 
													{ 0x21, 0x01, 0x00, 0x03, 0x00, 0x02, 0x01, 0x00, 0x00 },			//(28) 
					
													{ 0x21, 0x01, 0x00, 0x05, 0x00, 0x02, 0x01, 0x00, 0x00 },			//(32) 
													{ 0x21, 0x01, 0x01, 0x02, 0x00, 0x02, 0x02, 0x00, 0x00, 0xF4 },		//(36) 
													{ 0x21, 0x01, 0x02, 0x02, 0x00, 0x02, 0x02, 0x00, 0x00, 0xF4 },		//(40) 
													{ 0x01, 0x0B, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00 },					//(49) 
													{ 0x01, 0x0B, 0x04, 0x00, 0x01, 0x00, 0x00, 0x00 },					//(50) 
													{ 0x21, 0x01, 0x01, 0x02, 0x00, 0x02, 0x02, 0x00, 0x16, 0xF4 },		//(51) 
													{ 0x21, 0x01, 0x02, 0x02, 0x00, 0x02, 0x02, 0x00, 0x16, 0xF4 }		//(52) 
												};
												
												
audio_command_vct		g_audio_start_commands_soundstick[ NUM_OF_AUDIO_COMMANDS ]	= 			//	 Soundstick initialization
												{
													{ 0x01, 0x0B, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
													
													{ 0x21, 0x01, 0x00, 0x03, 0x00, 0x02, 0x01, 0x00, 0x00 },
													{ 0x21, 0x01, 0x00, 0x05, 0x00, 0x02, 0x01, 0x00, 0x00 },
													
//													{ 0x21, 0x01, 0x01, 0x02, 0x00, 0x02, 0x02, 0x00, 0xC9, 0xF0 },
//													{ 0x21, 0x01, 0x02, 0x02, 0x00, 0x02, 0x02, 0x00, 0xC9, 0xF0 },
													
													{ 0x21, 0x01, 0x01, 0x02, 0x00, 0x02, 0x02, 0x00, 0xFF, 0xFF },
													{ 0x21, 0x01, 0x02, 0x02, 0x00, 0x02, 0x02, 0x00, 0xFF, 0xFF },
													
													{ 0x01, 0x0B, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00 },
													{ 0x01, 0x0B, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00 },
												};


iso_ptd_header		g_iso_ptd0[ 4 ]	= 			{ 0x0800, 0x4150, 0x04B0, 0x0080 };		//	ISO PTD header (default target device : address 2)
iso_ptd_header		g_iso_ptd9[ 4 ]	= 			{ 0x0800, 0x4950, 0x04B4, 0x0080 };		//	ISO PTD header (default target device : address 2)

#ifdef	SMALLER_ISO_BUFFER
iso_ptd_header		g_iso_ptdL[ 4 ]	= 			{ 0x0800, 0x4950, 0x04B0, 0x0080 };		//	ISO PTD header (default target device : address 2)
#endif	//SMALLER_ISO_BUFFER

audio_index_size	g_audio_packet[ 10 ]	=											//	Audio packet parameters
												{
													{	176, g_iso_ptd0 },
													{	176, g_iso_ptd0 },
													{	176, g_iso_ptd0 },
													{	176, g_iso_ptd0 },
													{	176, g_iso_ptd0 },
													{	176, g_iso_ptd0 },
													{	176, g_iso_ptd0 },
													{	176, g_iso_ptd0 },
													{	176, g_iso_ptd0 },
													{	180, g_iso_ptd9 }
												};


unsigned short		(*g_buffer_fill_method)( short *p );
void				(*g_stop_process_method)( void );


int					g_file_handle		= 0;											//	File handle to access by _dos_open()/_dos_read()/_dos_close()
unsigned char		g_audio_source;
unsigned char		g_audio_current_target_device_address;								//	To point the current target aidio device address
unsigned long		g_audio_quit_timing;												//	Flag for play end delay

unsigned short		g_iso_buffer_size;

unsigned char		g_file_read_buffer_IN					= 0;
unsigned char		g_file_read_buffer_OUT					= 0;
unsigned char		g_sing_buffer_EMPTY						= True;

#ifdef	USE_AUDIO_PEAK_METER

unsigned long		g_peak_meter_left[  BUFFER_DEPTH ];
unsigned long		g_peak_meter_right[ BUFFER_DEPTH ];
unsigned char		g_peak_meter_scaling_level;

#endif

char				g_audio_device_addr						= 0;

char				g_audio_level							= 0;
char				g_audio_level_changed					= 0;
unsigned char		g_audio_mute							= False;

unsigned long		g_total_music_length_in_bytes			= 0L;
unsigned long		g_total_music_length_in_sec				= 0L;
unsigned long		g_current_music_time_in_bytes			= 0L;

unsigned char		g_previous_audio_state					= 1;

short				*g_audio_buffer							= NULL;
short				*g_file_read_buffer_ptr[ BUFFER_DEPTH ];

unsigned char		g_last_buffer[ BUFFER_DEPTH ];

unsigned char		g_audio_abort							= False;

unsigned char		g_audio_in_play							= False;


/****************************************************************************/
/*	function prototypes														*/
/****************************************************************************/

unsigned short	open_music_file( char *filename );
void			close_music_file( void );

void			audio_stop_process( void );

unsigned short 	sing_buffer_data_read( short *buffer_ptr );
unsigned short	audio_command( device_instance *dvi_ptr, unsigned char *com );
unsigned short 	music_file_read( short *buffer_ptr );

void			iso_transfer_service_from_file_by_ISTL( unsigned char buffer_number );
void 			iso_enable_buffer( unsigned char buffer_number );
void			iso_buffer_fill( unsigned char buffer_number, unsigned long frame_count_reference );
short 			*output_buffer_selection( void );
unsigned char	sing_buffer_stored_length( void );
void			sing_buffer_pointer_increment( unsigned char *v );
void			sing_buffer_reset( void );
void			sing_buffer_data_fill( void );
void			sing_buffer_volume_control( short *buffer_ptr, unsigned char level );

void			audio_status_monitor( unsigned char dummy );
unsigned char	get_music_number( void );


/****************************************************************************/
/*	function definitions													*/
/****************************************************************************/

unsigned char audio_main( unsigned char selection )
{
	device_instance		*dvi_ptr;
	
	if ( is_audio_active() )
	{
		audio_stop();
		audio_stop_process();
		mprintf( LIGHTGREEN, CONTINUE, "    audio play finished (by user termination).\r\n" );
		return ( 0xFF );
	}

	/*								*/
	/*  Audio start message			*/
	/*								*/
	
	mprintf( LIGHTGREEN, CONTINUE, "\r\n\r\n  AudioTest started\r\n" );


	/*								*/
	/*  Finding USB audio device	*/
	/*								*/
	
	if ( g_audio_device_addr == 0 )
	{
		mprintf( LIGHTGREEN, CONTINUE, "\r\n  Audio device can not be found.\r\n" );
		return ( NO_AUDIO_DEVICE );
	}
	
	mprintf( LIGHTGREEN, CONTINUE, "    target Audio device address : %d\r\n", g_audio_device_addr );
	
	dvi_ptr		= devep_find_device( g_audio_device_addr );
	

	/*								*/
	/*  Selection for music file	*/
	/*								*/

	if ( selection == AUDIO_PLAY_MANUAL_SELECTION )
		selection	= get_music_number();

	if ( (selection & 0xF0) == OTG_AUDIO_SPECIAL_CODE )
	{
		OTG_demo_host_side_2( selection & 0x0F );
		return ( 0 );
	}

#ifdef AUDIO_FROM_STORAGE
	if ( (selection & 0xF0) == STORAGE_AUDIO_SPECIAL_CODE )
	{
		char s[ 128 ];
		
		ui_get_string_from_console( s, 128, WHITE, "   USB storage play, Type path & file name >> ", YELLOW, 0, "/", NULL );
		mprintf( LIGHTGREEN, CONTINUE, "\r\n" );
		
		fsts_play( s );
		
		return ( 0 );
	}
#endif

	
	if ( !(selection < MAX_NUM_OF_AUDIO_FILES) )
	{
		mprintf( LIGHTGREEN, CONTINUE, "\r\n  Audio file can not be found.\r\n" );
		return ( NO_AUDIO_FILE );
	}

	mprintf( LIGHTGREEN, CONTINUE, "    music data source \"%s\"  (selection num : %d)\r\n", gp_sing_file_strings[ selection ].file_path_and_name, selection );


	/*								*/
	/*	Initialize Audio functions	*/
	/*								*/

	if ( 0 != audio_initialize( dvi_ptr, gp_sing_file_strings[ selection ].file_path_and_name, music_file_read, close_music_file ) )
		return ( AUDIO_INITIALIZATION_FAIL );
		
		
	/*								*/
	/*	Start to play Audio 		*/
	/*								*/

	audio_start();
	mprintf( LIGHTGREEN, CONTINUE, "    play started." );
	mprintf( LIGHTGREEN, CONTINUE, "    use keys " );
	mprintf( LIGHTRED,   CONTINUE, "[,]" );
	mprintf( LIGHTGREEN, CONTINUE, " and " );
	mprintf( LIGHTRED,   CONTINUE, "[.]" );
	mprintf( LIGHTGREEN, CONTINUE, " to adjust volume level.\r\n\r\n" );

	return ( 0 );
}


unsigned char is_audio_beep_play( void )
{
	return ( (g_audio_source == SOURCE_IS_NON_FILE) ? 1 : 0  );
}


unsigned char is_audio_active( void )
{
	return ( g_audio_current_target_device_address );
}


unsigned char is_audio_in_play( void )
{
	return ( g_audio_in_play );
}


unsigned char is_audio_exist( void )
{
	return ( g_audio_buffer ? True : False );
}




unsigned short swap( unsigned short x )
{
	unsigned short	tmp;
	
	tmp		= x << 8;
	
	return ( tmp | (x >> 8) );
}


unsigned short audio_initialize( device_instance *dvi_ptr, char *filename,  unsigned short (*buffer_fill_method)( short *p ), void (*stop_process)( void ) )
{
	short			*buffer;
	int				i;
	
	if ( NULL == filename )
	{
		g_audio_source		= SOURCE_IS_NON_FILE;
	}
	else if ( '*' == *filename )
	{
		g_audio_source		= SOURCE_IS_REMOTE_FILE;
	}
	else
	{
		g_audio_source	= SOURCE_IS_FILE;
	
		if ( open_music_file( filename ) )
			return ( 1 ); 
	}

	g_audio_current_target_device_address	= dvi_ptr->address;
	g_buffer_fill_method					= buffer_fill_method;
	g_stop_process_method					= stop_process;
	g_iso_buffer_size						= read_register16( Com16_HcISTLBufferSize );

#ifdef	USE_AUDIO_PEAK_METER

	g_peak_meter_scaling_level				= DEFAULT_SCALING_LEVEL;

#endif

	return ( 0 );
}


unsigned short open_music_file( char *filename )
{
	wave_header		wave_head;
	unsigned int	readsz;

	/*									*/
	/*	Open the music file				*/
	/*									*/

	if ( 0 != (_dos_open( filename, O_RDONLY, &g_file_handle )) )
	{
		mprintf( LIGHTRED, CONTINUE, "error @ wave file open\r\n" );

		return ( 1 );
	}
	
	g_total_music_length_in_bytes	= 0L;
	g_current_music_time_in_bytes	= 0L;

	
	/*									*/
	/*	Checking "wave" header			*/
	/*									*/
	
	_dos_read( g_file_handle, &wave_head, sizeof( wave_header ), &readsz );

	if ( !strncmp( wave_head.wave_h, "WAVE", 3 ) )		//	It may be wave format!
	{
		if (  wave_head.data_speed != 176400L )
		{
			mprintf( LIGHTGREEN, CONTINUE, "    \".wav file may not WASABI-Hot!  compatible format.\"\r\n" );
			return ( 2 );
		}
		else
		{
			int		min,
					sec,
					total_sec;
					
			g_total_music_length_in_bytes	= wave_head.data_sample_size_in_bytes;
			g_total_music_length_in_sec		= bytes_to_sec( wave_head.data_sample_size_in_bytes );
			
			total_sec	= g_total_music_length_in_sec;
			min			= g_total_music_length_in_sec / 60;
			sec			= g_total_music_length_in_sec % 60;
			
			mprintf( LIGHTGREEN, CONTINUE, "    play time %dmin %02dsec (%dseconds)\"\r\n", min, sec, total_sec );
		}
	}
	else
	{
		mprintf( LIGHTGREEN, CONTINUE, "    The file is not in \".wav\" format. It will play as raw data.\"\r\n" );

		//	re-open to seek reset

		_dos_close( g_file_handle );
		
		g_file_handle	= 0;

		if ( 0 != (_dos_open( filename, O_RDONLY, &g_file_handle )) )
		{
			mprintf( LIGHTRED, CONTINUE, "error @ wave file open\r\n" );
			return ( 1 );
		}
	}	
	
	return ( 0 );
}


void close_music_file( void )
{
	if ( g_file_handle )
		_dos_close( g_file_handle );
		
	g_file_handle	= 0;
		
	mprintf( LIGHTGRAY, CONTINUE, "    audio file closed.\r\n" );
}


unsigned short 	music_file_read( short *buffer_ptr )
{
	unsigned short	read_size;

	_dos_read( g_file_handle, (unsigned char *)buffer_ptr, (MEMORY_FILLING_SIZE_FROM_FILE << 1), (unsigned *)&read_size );

	g_current_music_time_in_bytes	+= read_size;

	return ( read_size >> 1 );	//	size convert from bytes to short
}




unsigned char	g_seq_play_num;
unsigned char	g_num_of_audio_files;
void			audio_sequential_play_control( void );


void audio_sequential_play( void )
{
	unsigned char		key;

	if ( NULL == gene_install_asynchronous_periodic_process( 3, NULL ) )
	{
		mprintf( LIGHTGREEN, CONTINUE, "\r\n  Audio jukebox mode started.\r\n" );
		
		for ( g_num_of_audio_files = 0; g_num_of_audio_files < MAX_NUM_OF_AUDIO_FILES; g_num_of_audio_files++ )
			if ( !(*gp_sing_file_strings[ g_num_of_audio_files ].file_path_and_name) )
				break;
				
		g_seq_play_num	= 0;
		gene_install_asynchronous_periodic_process( 3, audio_sequential_play_control );
	}
	else
	{
		mprintf( LIGHTGREEN, CONTINUE, "\r\n  Audio jukebox mode stopped.\r\n" );
	}
}


void audio_sequential_play_control( void )
{
	unsigned char			result;

	if ( is_audio_active() )
		return;
		
	mprintf( LIGHTRED, CONTINUE, "\r\n\r\n  ********** Audio sequential play mode ********** \r\n" );
	mprintf( LIGHTRED, CONTINUE, "          (press [j] to quit from ths mode) \r\n\r\n" );

	g_seq_play_num	= (g_seq_play_num < g_num_of_audio_files) ? g_seq_play_num : 0;

	while ( 1 )
	{
		result	= audio_main( g_seq_play_num++ );

		if ( !result )
			break;
			
		else if ( result == NO_AUDIO_FILE )
			continue;

		else
		{
			audio_sequential_play();
			break;	
		}
	}
}


/*********															*********/
/*																			*/
/*	Device class handling functions											*/
/*																			*/
/*		This functions is called from functions in cls_hndl.c as callback	*/
/*		functions. 															*/
/*		All these functions are needed to be installed by 					*/
/*		"clshndl_initialization_method_install()"	in "cls_hndl.c".			*/
/*																			*/
/*		These functions will be called at printer device attach/detach		*/
/*		events. 															*/
/*																			*/
/*********															*********/


unsigned short audio_init_commands( device_instance *dvi_ptr )
{
	audio_command_vct	*commands;
	unsigned short		vender_id;
	unsigned short		product_id;
	unsigned char		target_endpoint;
	unsigned short		err;
	unsigned char		i;
	
	if ( devep_regist_config_descriptors( dvi_ptr, 1, 0 ) )
		return ( 5 );
	
	if ( g_audio_device_addr != 0 )
	{
		//	Already audio device existing on the USB bus. Do nothing and quit.
		return ( 0 );
	}
	
	g_audio_buffer		= (short *)malloc( sizeof(short) * BUFFER_DEPTH * MEMORY_FILLING_SIZE_FROM_FILE );
	g_audio_device_addr	= dvi_ptr->address;

	if ( NULL == g_audio_buffer )
	{
		mprintf( LIGHTRED, CONTINUE, "malloc error @ audio_init_commands\r\n" );
		return( 2 );
	}

	for ( i = 0; i < BUFFER_DEPTH; i++ )
		g_file_read_buffer_ptr[ i ]			= g_audio_buffer + MEMORY_FILLING_SIZE_FROM_FILE * i;

	vender_id		= (dvi_ptr->dev_descriptor).idVendor;
	product_id		= (dvi_ptr->dev_descriptor).idProduct;

	if ( (vender_id == 0x05FC) && (product_id == 0x7849) )
	{
		//	This is harman/kardon Soundstick

		target_endpoint		= 1;

		for ( i = 0; i < 7; i++ )
			if ( 0 != (err	= audio_command( dvi_ptr, (g_audio_start_commands_soundstick + i)->com )) )
				return ( err );		
	}
	else
	{
		if ((product_id & 0xFFF0) == AUDIO_CODEC)
			commands	= g_audio_start_commands_codec;
		else if ((product_id & 0xFFF0) == AUDIO_DAC)
			commands	= g_audio_start_commands_dac;
		
		target_endpoint		= 4;

		for ( i = 0; i < NUM_OF_AUDIO_COMMANDS; i++ )
			if ( 0 != (err	= audio_command( dvi_ptr, (commands + i)->com )) )
				return ( err );
	}


	g_iso_ptd0[ 1 ]				= (g_iso_ptd0[ 1 ] & 0x0FFF) | (target_endpoint << 12);
	g_iso_ptd9[ 1 ]				= (g_iso_ptd9[ 1 ] & 0x0FFF) | (target_endpoint << 12);
	
#ifdef	SMALLER_ISO_BUFFER
	g_iso_ptdL[ 1 ]				= (g_iso_ptdL[ 1 ] & 0x0FFF) | (target_endpoint << 12);
//	mprintf( LIGHTRED, CONTINUE, "SMALLER_ISO_BUFFER\r\n" );
#endif	//SMALLER_ISO_BUFFER

	dvi_ptr->class_instance_ptr	= (void *)0x1;	//	Dummy : To call audio_dispose_process() at device detach
	g_previous_audio_state		= 1;

	{
		char				s0[ 128 ];
		char				s1[ 128 ];
		unsigned char		length0;
		unsigned char		length1;
		unsigned char		i;

		length0		= (((std_string_descriptor *)(dvi_ptr->string_manufacturer))->bLength) >> 1;
		length1		= (((std_string_descriptor *)(dvi_ptr->string_product     ))->bLength) >> 1;
		
		ui_unicode_to_C_string( s0, (dvi_ptr->string_manufacturer) + 1, length0 );
		ui_unicode_to_C_string( s1, (dvi_ptr->string_product     ) + 1, length1 );
		
		if ( (length0 + 1 + length1) >= AUDIO_DEVICE_NAME_STR_LENGTH )
		{
			length1				= (length1 < AUDIO_DEVICE_NAME_STR_LENGTH) ? length1 : (AUDIO_DEVICE_NAME_STR_LENGTH - 1);
			*(s1 + length1)		= 0;
			
			sprintf( g_audio_device_name, "(%s)", s1 );
		}
		else		
		{
			sprintf( g_audio_device_name, "(%s %s)", s0, s1 );
		}
		
		for ( i = strlen( g_audio_device_name ); i < (AUDIO_DEVICE_NAME_STR_LENGTH + 2); i++ )
			*(g_audio_device_name + i)	= ' ';
		
		*(g_audio_device_name + (AUDIO_DEVICE_NAME_STR_LENGTH + 2))		= 0;
	}
	
	ui_install_status_monitor_custom_routine( AUDIO_STATUS_MONITOR_LINE, audio_status_monitor );

	return ( 0 );
}


unsigned short audio_dispose_process( device_instance *target_device_ptr )
{
	device_instance		*dvi_ptr;

	g_previous_audio_state		= NULL;
	ui_install_status_monitor_custom_routine( AUDIO_STATUS_MONITOR_LINE, NULL );

	free( g_audio_buffer );
	g_audio_buffer			= NULL;
	g_audio_device_addr		= 0;
	

	//	Search altanative audio device on USB.

	(target_device_ptr->interfacef_descriptor).bInterfaceClass		= 0xFF;		//	Modify current device bInterfaceClass first

	if ( NULL != (dvi_ptr	= devep_find_class_interface( AUDIO_CLASS_INTERFACE, 0 )) )
	{
		mprintf( LIGHTRED, CONTINUE, "switching audio device\r\n" );
		audio_init_commands( dvi_ptr );
	}

	return ( 0 );
}


static unsigned short audio_command( device_instance *dvi_ptr, unsigned char *com )
{
	unsigned short		request,
						wValue,
						wIndex,
						wLength;

	request		= short_swap( *((unsigned short *)(com + 0)) );
	wValue		= *((unsigned short *)(com + 2));
	wIndex		= *((unsigned short *)(com + 4));
	wLength		= *((unsigned short *)(com + 6));

	return ( devep_std_request( (com + 8), dvi_ptr, request, wValue, wIndex, &wLength ) );
}






/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//  New for ISTL control  ///////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////



#ifdef	SMALLER_ISO_BUFFER
#define	ISTL_TOGGLE_RATE					5										//	Toggle rate
#else
#define	ISTL_TOGGLE_RATE					10										//	Toggle rate
#endif	//SMALLER_ISO_BUFFER

#define		ISO_START_OFFSET				255										//	This must be 255 or less

#define		PTD_HEAD_OFFSET					1										//	ISTL enabling timing before starting target frame


void audio_start( void )
{
	unsigned long		start_frame;
	unsigned long		t_frame;
	unsigned char		i;
	
	g_audio_quit_timing		= 0;													//	audio play quitting flag
	g_audio_abort			= False;
	
	isr_install_ISTL_service_routine( NULL );											//	Removing ISR for ISTL interrupt

	start_frame		= isr_get_frame_number() + (ISTL_TOGGLE_RATE << 1);
	
	while ( isr_get_frame_number() < start_frame )										//	Wait for previous ISTL data go out
		;

	sing_buffer_reset();															//	Reset the application buffer state

	for ( i = 0; i < BUFFER_DEPTH; i++ )
		sing_buffer_data_fill();													//	Pre-filling application buffer

	start_frame			= ((isr_get_frame_number() + ISO_START_OFFSET) / ISTL_TOGGLE_RATE) * ISTL_TOGGLE_RATE;		//	To make frame start ISTL_TOGGLE_RATE*N for debugging easy

	iso_buffer_fill( 0, start_frame + ISTL_TOGGLE_RATE                    );		//	Filling ISTL buffer 0
	iso_buffer_fill( 1, start_frame + ISTL_TOGGLE_RATE + ISTL_TOGGLE_RATE );		//	Filling ISTL buffer 1

	gene_install_asynchronous_periodic_process( 0, sing_buffer_data_fill );				//	This is to fill application buffer in non-ISR context

	while ( (isr_get_frame_number() & 0xFF) != ((start_frame - PTD_HEAD_OFFSET) & 0xFF) )	//	Wait for ISTL enabling timing
		;

	write_register16( Com16_HcISTLToggleRate, ISTL_TOGGLE_RATE );					//	Set ISTL toggle rate
	isr_install_ISTL_service_routine( iso_transfer_service_from_file_by_ISTL );			//	Installing ISR for ISTL interrupt

	iso_enable_buffer( 0 );															//	Enable ISTL buffer 0
	iso_enable_buffer( 1 );															//	Enable ISTL buffer 1

	g_audio_in_play		= True;
}


void audio_stop( void )
{
//	write_register16( Com16_HcISTLToggleRate, 0 );
	isr_install_ISTL_service_routine( NULL );

	g_audio_abort	= True;
}


void audio_stop_process( void )
{
	gene_install_asynchronous_periodic_process( 0, NULL );

	g_buffer_fill_method					= NULL;
	g_audio_current_target_device_address	= 0;

	g_audio_in_play		= False;

	if ( g_stop_process_method )
		(*g_stop_process_method)();
		
	g_stop_process_method	= NULL;
}


void iso_transfer_service_from_file_by_ISTL( unsigned char buffer_number )
{
	unsigned long	next_buffer_start_frame;
	
	if ( g_audio_abort )
		return;

	next_buffer_start_frame		= ((isr_get_frame_number() + 1) / ISTL_TOGGLE_RATE) * ISTL_TOGGLE_RATE + ISTL_TOGGLE_RATE;

	iso_buffer_fill( buffer_number, next_buffer_start_frame );
	iso_enable_buffer( buffer_number );
}


void iso_enable_buffer( unsigned char buffer_number )
{
	write_register16( Com16_HcBufferStatus, read_register16( Com16_HcBufferStatus ) | (0x0001 << buffer_number) );
}


void iso_buffer_fill( unsigned char buffer_number, unsigned long frame_count_reference )
{
	short					*source_buffer;
	unsigned short			read_size;
	unsigned char			target_addr;
	unsigned char			target_port_register;
	unsigned short			target_buffer_direct_address;
	unsigned short			packet_size;
	unsigned short			i;
	unsigned char			loop_start;
	unsigned char			loop_lim;


	if ( g_audio_abort )
		return;
	
	target_addr				= g_audio_current_target_device_address;
	
	if ( NULL == devep_find_device( target_addr ) )
	{
		audio_stop();
		return;
	}
	
	//
	//	Fill application buffer for next ISTL buffer filling
	//
	
	if ( SING_BUFFER_EMPTY == sing_buffer_stored_length() )
	{
		if ( (g_audio_source != SOURCE_IS_REMOTE_FILE) && !g_audio_abort && !gp_is_in_DOS_environment )
			sing_buffer_data_fill();
		else
		{
			audio_stop();
			return;
		}
	}


	//
	//	Fill ISTL buffer
	//
	
	source_buffer					= g_file_read_buffer_ptr[ g_file_read_buffer_OUT ];
	target_buffer_direct_address	= (buffer_number == 0) ? 0 : g_iso_buffer_size;

#ifdef	SMALLER_ISO_BUFFER
	if ( buffer_number )
	{
		source_buffer	+= ((g_audio_packet[ 0 ].size >> 1) * 5);
		g_audio_packet[ 4 ].iso_header_ptr		= g_iso_ptd9;

		loop_start		= 5;
		loop_lim		= 10;
	}
	else
	{
		g_audio_packet[ 4 ].iso_header_ptr		= g_iso_ptdL;

		loop_start		= 0;
		loop_lim		= 5;
	}
#else	//SMALLER_ISO_BUFFER
		loop_start		= 0;
		loop_lim		= ISTL_TOGGLE_RATE;
#endif	//SMALLER_ISO_BUFFER

	for ( i = loop_start; i < loop_lim; i++ )
	{
		//	copies audio samples with PTD header into ISTL buffer
		
		packet_size									= g_audio_packet[ i ].size;
		*(g_audio_packet[ i ].iso_header_ptr + 3)	= target_addr | 0x00 | (((unsigned short)frame_count_reference++) << 8);
	
		write_direct_access( target_buffer_direct_address, (unsigned char *)(g_audio_packet[ i ].iso_header_ptr), 8 );
		target_buffer_direct_address	+= 8;
		
		//	copies PTD data body (audio samples) in to ISTL buffer
		
		write_direct_access( target_buffer_direct_address, (unsigned char *)source_buffer, packet_size );
		
		//	update pointers for source and target buffers
		
		source_buffer					+= (packet_size >> 1);		//	update source buffer pointer by size of short
		target_buffer_direct_address	+=  packet_size;			//	update target buffer pointer by size of unsigned char
	}
	
#ifdef	SMALLER_ISO_BUFFER
	if ( !buffer_number )
		return;
#endif	//SMALLER_ISO_BUFFER
	
	if ( True == g_last_buffer[ g_file_read_buffer_OUT ] )
	{
		audio_stop();
		return;
	}
	
	sing_buffer_pointer_increment( &g_file_read_buffer_OUT );		//	update application buffer index for OUT

	if ( g_file_read_buffer_IN == g_file_read_buffer_OUT )			//	if INPUT==OUTPUT after OUTPUT++, that means the application buffer is empty
	{
		g_sing_buffer_EMPTY 	= True;
	}
}


void sing_buffer_data_fill( void )
{
	static unsigned char	flag = 0;
	
	if ( flag )
		return;

#ifdef SHOW_SING_BUFFER_STATUS
	mprintf( WHITE, CONTINUE, "\r\n[out]  i=%-2d  o=%-2d  buffer stat = %-2d   %-2d", g_file_read_buffer_IN, g_file_read_buffer_OUT, sing_buffer_stored_length(), g_sing_buffer_EMPTY );
#endif

	if ( g_audio_abort )
	{
		audio_stop_process();
		return;
	}

	if ( SING_BUFFER_FULL == sing_buffer_stored_length() )			//	do nothing if the application buffer is full
		return;

	flag	= 1;

	sing_buffer_data_read( g_file_read_buffer_ptr[ g_file_read_buffer_IN ] );
	sing_buffer_volume_control( g_file_read_buffer_ptr[ g_file_read_buffer_IN ], g_audio_level );
	
	sing_buffer_pointer_increment( &g_file_read_buffer_IN );		//	update application buffer index for INPUT
	g_sing_buffer_EMPTY		= False;								//	the application buffer is not empty anymore
	
	flag = 0;
}


unsigned short 	sing_buffer_data_read( short *buffer_ptr )
{
	unsigned short	(*bf_filling_method)( short *buffer_ptr );
	unsigned short	read_size;
	unsigned short	i;

	bf_filling_method	= g_buffer_fill_method;

	if ( bf_filling_method )
		read_size	= (*bf_filling_method)( buffer_ptr );
	else
		return ( 0 );
	
	if ( read_size != MEMORY_FILLING_SIZE_FROM_FILE )
	{
//		gene_install_asynchronous_periodic_process( 0, NULL );		//	Stop buffer filling
		g_buffer_fill_method						= NULL;		//	Stop buffer filling
		
		g_last_buffer[ g_file_read_buffer_IN ]		= True;

		for ( i = read_size; i < MEMORY_FILLING_SIZE_FROM_FILE; i++ )
			*buffer_ptr++	= 0;
	}

	return ( read_size );	//	size convert from bytes to short
}


unsigned char sing_buffer_stored_length( void )
{
	unsigned char	in;
	unsigned char	out;

	if ( g_sing_buffer_EMPTY == True )
		return ( SING_BUFFER_EMPTY );		//	returns value 0 (SING_BUFFER_EMPTY) if it is empty
	else
	{
		in		= g_file_read_buffer_IN;
		out		= g_file_read_buffer_OUT;
	
		if ( in <= out )
			in	+= BUFFER_DEPTH;
			
		return ( in - out );				//	returns value from 1 to BUFFER_DEPTH
	}
}


void sing_buffer_pointer_increment( unsigned char *v )
{
	*v	= (*v + 1) & (BUFFER_DEPTH - 1);
}


void sing_buffer_reset( void )
{
	unsigned char	i;

	g_file_read_buffer_IN		= 0;
	g_file_read_buffer_OUT		= 0;
	g_audio_quit_timing			= 0;
	g_sing_buffer_EMPTY 		= True;
	
	for ( i = 0; i < BUFFER_DEPTH; i++ )
		g_last_buffer[ i ]	= False;
}



void sing_buffer_volume_control( short *buffer_ptr, unsigned char level )
{

#define		M_2_dB		52016
#define		M_4_dB		41285

	unsigned short	i;
	unsigned short	shift;
	unsigned short	step;
	long			k;

#ifdef	USE_AUDIO_PEAK_METER

	unsigned long	lev_l	= 0;
	unsigned long	lev_r	= 0;

#endif

	if ( g_audio_mute )
	{
		for ( i = 0; i < MEMORY_FILLING_SIZE_FROM_FILE; i += 2 )
		{
			*buffer_ptr++	= 0;
			*buffer_ptr++	= 0;
		}

		return;
	}

	shift	= level / 3;
	step	= level % 3;
	
	if ( step )
	{
		if ( step == 1 )
			k	= M_2_dB;
		else if ( step == 2 )
			k	= M_4_dB;
		
		for ( i = 0; i < MEMORY_FILLING_SIZE_FROM_FILE; i += 2 )
		{
		
#ifdef	USE_AUDIO_PEAK_METER

			lev_l		+= ((*(buffer_ptr    )) & 0x8000) ? ~(*(buffer_ptr    )) : (*(buffer_ptr    ));
			lev_r		+= ((*(buffer_ptr + 1)) & 0x8000) ? ~(*(buffer_ptr + 1)) : (*(buffer_ptr + 1));

#endif
		
			*buffer_ptr++		= ((long)(*buffer_ptr) * k) >> (16 + shift);
			*buffer_ptr++		= ((long)(*buffer_ptr) * k) >> (16 + shift);
		}
	}
	else
	{
		for ( i = 0; i < MEMORY_FILLING_SIZE_FROM_FILE; i += 2 )
		{
		
#ifdef	USE_AUDIO_PEAK_METER

			lev_l		+= ((*(buffer_ptr    )) & 0x8000) ? ~(*(buffer_ptr    )) : (*(buffer_ptr    ));
			lev_r		+= ((*(buffer_ptr + 1)) & 0x8000) ? ~(*(buffer_ptr + 1)) : (*(buffer_ptr + 1));
#endif
		
			*buffer_ptr++		>>= shift;
			*buffer_ptr++		>>= shift;
		}
	}

#ifdef	USE_AUDIO_PEAK_METER

	g_peak_meter_left[  g_file_read_buffer_IN ]		= lev_l;
	g_peak_meter_right[ g_file_read_buffer_IN ]		= lev_r;
	
	audio_peak_indicator();

#endif
}


#ifdef		USE_AUDIO_PEAK_METER
//#define		SYNMETRICAL_METER

void audio_peak_indicator( void )
{
	unsigned long	l;
	unsigned long	r;
	char			ls[]	= "                                      ";
	char			rs[]	= "                                      ";
//							   1234567890123456789012345678901234567890

	if ( !gp_is_in_DOS_environment || (g_audio_source == SOURCE_IS_NON_FILE) )
		return;
		
	l	= g_peak_meter_left[  g_file_read_buffer_OUT ];
	r	= g_peak_meter_right[ g_file_read_buffer_OUT ];

	if ( (l >> (g_peak_meter_scaling_level + 6)) || (r >> (g_peak_meter_scaling_level + 6)) )
		g_peak_meter_scaling_level++;
		
	l	>>= g_peak_meter_scaling_level;
	r	>>= g_peak_meter_scaling_level;


#ifdef SYNMETRICAL_METER

	l	= 37 - ((l > 37) ? 37 : l);
	r	= ((r > 37) ? 37 : r);

	*(ls + l)	= 0;
	*(rs + r)	= 0;

	mprintf( (BLACK    << 4) | BLACK,    CONTINUE, "%s", ls );
	mprintf( (WHITE    << 4) | BLACK,    CONTINUE, "%s", ls + l + 1 );
	mprintf( (LIGHTRED << 4) | BLACK,    CONTINUE, "%s", rs );
	mprintf( (BLACK    << 4) | BLACK,    CONTINUE, "%s", rs + r + 1 );

#else

	l	= ((l > 37) ? 35 : l);
	r	= ((r > 37) ? 35 : r);

	*(ls + l)	= 0;
	*(rs + r)	= 0;

	mprintf( (WHITE    << 4) | BLACK,    CONTINUE, "%s", ls );
	mprintf( (BLACK    << 4) | BLACK,    CONTINUE, "%s", ls + l + 1 );
	mprintf( (LIGHTRED << 4) | BLACK,    CONTINUE, "%s", rs );
	mprintf( (BLACK    << 4) | BLACK,    CONTINUE, "%s", rs + r + 1 );
	
#endif

	mprintf( (BLACK << 4) | BLACK,    CONTINUE, "\r" );
}

#endif





void audio_volume_down( void )
{
	audio_volume_value_set( g_audio_level + 1 );
}


void audio_volume_up( void )
{
	audio_volume_value_set( g_audio_level - 1 );
}


void audio_volume_set_delta( char delta )
{
	audio_volume_value_set( g_audio_level + delta );
}


unsigned char audio_volume_mute_toggle( void )
{
	g_audio_mute			= g_audio_mute ? False : True;
	g_audio_level_changed	= AUDIO_LEVEL_CHANGE_TIMELIMIT;
	
	return ( g_audio_mute );
}


char audio_volume_value_set( char value )
{
	if ( (value == GET_CURRENT_VOLUME_LEVEL) || g_audio_mute )
		return ( g_audio_level );

	value	= ( value        < 0     ) ? 0            : value;
	value	= ( VOLUME_LIMIT < value ) ? VOLUME_LIMIT : value;
	
	g_audio_level			= value;
	g_audio_level_changed	= AUDIO_LEVEL_CHANGE_TIMELIMIT;
	return ( value );
}






/*********															*********/
/*																			*/
/*	User interface (to show the audio status) function						*/
/*																			*/
/*		This functions is called from "ui_status_monitor()" in "ui.c" as 		*/
/*		callback function. 													*/
/*		This routine will be installed by "audio_init_commands()" at		*/
/*		audio device enumeration.											*/
/*																			*/
/*********															*********/

#if 0

void audio_status_monitor( unsigned char dummy_for_func_compatibility )
{
	unsigned char	state_change_happened;
	unsigned char	buffer_state;
	unsigned char	buffer_state_color;
	
	dummy_for_func_compatibility	= dummy_for_func_compatibility;		//	This line for erase warning
	
	state_change_happened	= g_audio_current_target_device_address ^ g_previous_audio_state;

	if ( g_audio_level_changed )
	{
		g_audio_level_changed--;

		gotoxy( 1, wherey() );
		mprintf( BG_BLUE | WHITE       , CONTINUE, "    Audio  " );
		mprintf( BG_BLUE | LIGHTGRAY   , CONTINUE, "(addr %2u) : ", g_audio_device_addr );

		if ( g_audio_level_changed == (AUDIO_LEVEL_CHANGE_TIMELIMIT - 1) )
		{
			if ( g_audio_mute )
			{
				mprintf( BG_BLUE | LIGHTRED    , CONTINUE, "Mute ON                                                " );
			}
			else
			{		
				mprintf( BG_BLUE | WHITE    , CONTINUE, "Volume  |---------+---------+--------| %-02ddB         ", g_audio_level * dB_STEP );
				gotoxy( wherex() - g_audio_level - 15, wherey() );
				mprintf( BG_BLUE | YELLOW    , CONTINUE, "*" );
			}
			return;
		}
		else if  ( g_audio_level_changed == 1 )
		{
			state_change_happened	= True;
		}
		else
		{
			if ( g_audio_mute )
				g_audio_level_changed	= AUDIO_LEVEL_CHANGE_TIMELIMIT - 2;		//	To keep indication on screen

			return;
		}
	}

	if ( state_change_happened )
	{
		if ( g_audio_current_target_device_address )
		{
			gotoxy( 1, wherey() );
			mprintf( BG_BLUE | WHITE       , CONTINUE, "    Audio  " );
			mprintf( BG_BLUE | LIGHTGRAY   , CONTINUE, "(addr %2u) : ", g_audio_device_addr );

			mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, "USB speaker is " );
			
			if ( g_audio_source == SOURCE_IS_FILE )
			{
				mprintf( BG_BLUE | WHITE,     CONTINUE, "singing" );
				mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, ". remaining play time = %03lusec", g_total_music_length_in_sec - bytes_to_sec( g_current_music_time_in_bytes ) );
			}
			else if ( g_audio_source == SOURCE_IS_REMOTE_FILE )
			{
				mprintf( BG_BLUE | WHITE,     CONTINUE, "singing" );
				mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, ". (remote file)  Bf state = " );
			}
			else
			{
				mprintf( BG_BLUE | WHITE    , CONTINUE, "beeping                               " );
			}
		}
		else
		{
			//	Audio play finished
		
			gotoxy( 1, wherey() );
			mprintf( BG_BLUE | WHITE       , CONTINUE, "    Audio  " );
			mprintf( BG_BLUE | LIGHTGRAY   , CONTINUE, "(addr %2u) : ", g_audio_device_addr );

			mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, "USB speaker ready. Press [a] key to play music        " );
		}
	}

	if ( g_audio_current_target_device_address && (g_audio_source == SOURCE_IS_FILE) )
	{
		buffer_state	= sing_buffer_stored_length();
	
		if ( 29 < buffer_state )
			buffer_state_color		= WHITE;
		else if ( 3 < buffer_state )
			buffer_state_color		= YELLOW;
		else
			buffer_state_color		= LIGHTRED;
	
		gotoxy( 39, wherey() );
		mprintf( BG_BLUE | buffer_state_color, CONTINUE, "singing" );
		
		gotoxy( 70, wherey() );
		mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, "%03lu", g_total_music_length_in_sec - bytes_to_sec( g_current_music_time_in_bytes ) );
	}
	else if ( g_audio_current_target_device_address && (g_audio_source == SOURCE_IS_REMOTE_FILE) )
	{
		buffer_state	= sing_buffer_stored_length();
	
		if ( 29 < buffer_state )
			buffer_state_color		= WHITE;
		else if ( 3 < buffer_state )
			buffer_state_color		= YELLOW;
		else
			buffer_state_color		= LIGHTRED;
	
		gotoxy( 39, wherey() );
		mprintf( BG_BLUE | buffer_state_color, CONTINUE, "singing" );
		
		gotoxy( 74, wherey() );
		mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, "%02u", buffer_state );
	}
	
	g_previous_audio_state		= g_audio_current_target_device_address;
}


#else

void audio_status_monitor( unsigned char dummy_for_func_compatibility )
{
	unsigned char	state_change_happened;
	unsigned char	buffer_state;
	unsigned char	buffer_state_color;
	
	dummy_for_func_compatibility	= dummy_for_func_compatibility;		//	This line for erase warning
	
	state_change_happened	= g_audio_current_target_device_address ^ g_previous_audio_state;

	if ( g_audio_level_changed )
	{
		g_audio_level_changed--;
	
		if ( g_audio_level_changed == (AUDIO_LEVEL_CHANGE_TIMELIMIT - 1) )
		{
			if ( g_audio_mute )
			{
				mprintf( BG_BLUE | WHITE       , CONTINUE, "    Audio            : " );
				mprintf( BG_BLUE | LIGHTRED    , CONTINUE, "Mute ON                                                " );
			}
			else
			{		
				mprintf( BG_BLUE | WHITE    , CONTINUE, "    Audio            : Volume  |---------+---------+--------| %-02ddB         ", g_audio_level * dB_STEP );
				gotoxy( wherex() - g_audio_level - 15, wherey() );
				mprintf( BG_BLUE | YELLOW    , CONTINUE, "*" );
			}
			return;
		}
		else if  ( g_audio_level_changed == 1 )
		{
			state_change_happened	= True;
		}
		else
		{
			if ( g_audio_mute )
				g_audio_level_changed	= AUDIO_LEVEL_CHANGE_TIMELIMIT - 2;		//	To keep indication on screen

			return;
		}
	}

	if ( state_change_happened )
	{
		if ( g_audio_current_target_device_address )
		{
			mprintf( BG_BLUE | WHITE    , CONTINUE, "    Audio            : " );
			mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, "USB speaker is " );
			
			if ( g_audio_source == SOURCE_IS_FILE )
			{
				mprintf( BG_BLUE | WHITE,     CONTINUE, "singing" );
				mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, ". remaining play time = %03lusec", g_total_music_length_in_sec - bytes_to_sec( g_current_music_time_in_bytes ) );
			}
			else if ( g_audio_source == SOURCE_IS_REMOTE_FILE )
			{
				mprintf( BG_BLUE | WHITE,     CONTINUE, "singing" );
				mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, ". (remote file)  Bf state = " );
			}
			else
			{
				mprintf( BG_BLUE | WHITE    , CONTINUE, "beeping                               " );
			}
		}
		else
		{
			//	Audio play finished
		
			mprintf( BG_BLUE | WHITE    , CONTINUE, "    Audio            " );
//			mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, ": USB speaker ready. Press [a] key to play music        " );
			mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, ": ready. %s", g_audio_device_name );
		}
	}

	if ( g_audio_current_target_device_address && (g_audio_source == SOURCE_IS_FILE) )
	{
		buffer_state	= sing_buffer_stored_length();
	
		if ( 29 < buffer_state )
			buffer_state_color		= WHITE;
		else if ( 3 < buffer_state )
			buffer_state_color		= YELLOW;
		else
			buffer_state_color		= LIGHTRED;
	
		gotoxy( 39, wherey() );
		mprintf( BG_BLUE | buffer_state_color, CONTINUE, "singing" );
		
		gotoxy( 70, wherey() );
		mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, "%03lu", g_total_music_length_in_sec - bytes_to_sec( g_current_music_time_in_bytes ) );
	}
	else if ( g_audio_current_target_device_address && (g_audio_source == SOURCE_IS_REMOTE_FILE) )
	{
		buffer_state	= sing_buffer_stored_length();
	
		if ( 29 < buffer_state )
			buffer_state_color		= WHITE;
		else if ( 3 < buffer_state )
			buffer_state_color		= YELLOW;
		else
			buffer_state_color		= LIGHTRED;
	
		gotoxy( 39, wherey() );
		mprintf( BG_BLUE | buffer_state_color, CONTINUE, "singing" );
		
		gotoxy( 74, wherey() );
		mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, "%02u", buffer_state );
	}
	
	g_previous_audio_state		= g_audio_current_target_device_address;
}

#endif





unsigned char get_music_number( void )
{
	char				s[ 40 ];
	unsigned char		selection;
	unsigned char		selection_lim;
	int					i;

//	if ( !(*(gp_sing_file_strings[ 2 ].file_path_and_name)) )
//		return ( 0 );
	
	mprintf( WHITE, CONTINUE, "\r\n    music file list (local peer) :\r\n" );
//	mprintf( WHITE, CONTINUE,     "    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^\r\n" );

	for ( i = 0; i < MAX_NUM_OF_AUDIO_FILES; i++ )
	{
		if ( !(*gp_sing_file_strings[ i ].file_path_and_name) )
			break;
			
		mprintf( LIGHTRED, CONTINUE, "      [%d]   ", i );
		
		strncpy( s, gp_sing_file_strings[ i ].file_path_and_name, 25 );
		*(s + 25)	= 0;
		mprintf( WHITE, CONTINUE, "%-25s", s );

		strncpy( s, gp_sing_file_strings[ i ].file_comment, 38 );
		*(s + 38)	= 0;
		mprintf( WHITE, CONTINUE, "  : %s", s );
		mprintf( WHITE, CONTINUE, "\r\n" );
	}
	
	selection_lim	= i;

	for ( ; i < MAX_NUM_OF_AUDIO_FILES; i++ )
		mprintf( RED, CONTINUE, "      [%d]\r\n", i );
	
#if 1
#ifdef AUDIO_FROM_STORAGE

	if ( storage_volume_ready() )
	{
		mprintf( LIGHTRED, CONTINUE,   "      [a]" );
		mprintf( LIGHTCYAN, CONTINUE,  "|" );
		mprintf( LIGHTRED, CONTINUE,   "[o]" );
		mprintf( LIGHTCYAN, CONTINUE,  " for OTG, " );
		mprintf( LIGHTRED, CONTINUE,   "[s]" );
		mprintf( LIGHTCYAN, CONTINUE,  " for USB-storage" );
	}
	else
	{
		mprintf( LIGHTRED, CONTINUE,   "      [a]" );
		mprintf( LIGHTCYAN, CONTINUE,  " or " );
		mprintf( LIGHTRED, CONTINUE,   "[o]" );
		mprintf( LIGHTCYAN, CONTINUE,  " for OTG remote file play..." );
	}

#else	//	AUDIO_FROM_STORAGE

	mprintf( LIGHTRED, CONTINUE,   "      [a]" );
	mprintf( LIGHTCYAN, CONTINUE,  " or " );
	mprintf( LIGHTRED, CONTINUE,   "[o]" );
	mprintf( LIGHTCYAN, CONTINUE,  " for OTG remote file play..." );

#endif	//	AUDIO_FROM_STORAGE

	mprintf( YELLOW, CONTINUE,     "          your selection : [ ]" );
	
	gotoxy( wherex() - 2, wherey() );

	selection	= ui_key_wait();
	
	mprintf( YELLOW, CONTINUE, "%c]\r\n\r\n", selection );
	
#else	//	1

	mprintf( LIGHTRED, CONTINUE, "      [a]" );
	mprintf( LIGHTCYAN, CONTINUE, " or " );
	mprintf( LIGHTRED, CONTINUE, "[o]" );
	mprintf( LIGHTCYAN, CONTINUE, " for OTG remote file play...\r\n" );
	mprintf( YELLOW, CONTINUE, "                                           your selection : [ ]\r" );
	mprintf( YELLOW, CONTINUE, "                                           your selection : [" );
	
	selection	= ui_key_wait();
	
	mprintf( YELLOW, CONTINUE, "\r                                           your selection : [%c]\r\n\r\n", selection );
	
#endif	//	1

	if ( selection == 0x0D )
		selection	= 0;
	else if ( (selection == 'O') || (selection == 'o') || (selection == 'A') || (selection == 'a') )
		selection	= OTG_AUDIO_SPECIAL_CODE | OTG_AUDIO_MANUAL_SELECTION;

#ifdef AUDIO_FROM_STORAGE

	else if ( (selection == 'S') || (selection == 's') )
	{
		if ( storage_volume_ready() )
			selection	= STORAGE_AUDIO_SPECIAL_CODE;
		else
		{
			mprintf( LIGHTRED,   CONTINUE, "\r\n  USB-storage volume " );
			mprintf( LIGHTGREEN, CONTINUE, "is not ready to use.\r\n" );
			return ( 0xFF );
		}
	}
#endif	//	AUDIO_FROM_STORAGE

	else
		selection	-= '0';

	if ( !(selection & 0xF0) )
		if ( !(selection < selection_lim) )
			return ( 0xFF );
	
	return ( selection );
}






















