/*
**  WASABI-Hot! version 1.2c   
**
**
**      -- copyright (c) 2001-2004 by Philips Japan, Ltd. -- All rights reserved --
**
**
**      ** This code has been made to check/learn                          ** 
**      **                             the ISP1362/ISP1363 functionalities **
**      ** Release 06-Aug-2004                                             **
**
**      OKANO, Akifumi
**      
**		Application Laboratory, Mobile and Connectivity
**      Semiconductors Div, Philips Japan Ltd.
**      akifumi.okano@philips.com
**      +81-3-3740-4668 
*/


/****************************************************************************/
/*	includes																*/
/****************************************************************************/

#include		<stdio.h>
#include		<stdlib.h>
#include		<alloc.h>
#include		<string.h>
#include		<dos.h>
#include		<conio.h>
#include		<bios.h>
#include		<ctype.h>
#include		<time.h>

#include		"general.h"

#include		"_hc_core/atl_mix.h"
#include		"_hc_core/dev_ep.h"
#include		"_hc_core/init.h"
#include		"_hc_core/isr.h"
#include		"_hc_core/port_ctl.h"
#include		"_hc_core/transfer.h"
#include		"_hc_hw/hc_comm.h"
#include		"_hc_hw/hw_acces.h"

#include		"_hc_cls/cls_hndl.h"

#include		"_dc/dc_flags.h"
#include		"_dc/dc_main.h"
#include		"_dc/dc_isr.h"
#include		"_dc/dc_comm.h"

#include		"class_dr/audio/sing.h"
#include		"class_dr/hub/hub.h"
#include		"class_dr/printer/printer.h"
#include		"class_dr/hid/hid.h"
#include		"class_dr/storage/fs_shell.h"

#include 		"_otg/otg.h"
#include 		"_otg/otg_demo.h"


#include		"beep.h"
#include		"ui.h"
#include		"griffin.h"


/****************************************************************************/
/*	constants																*/
/****************************************************************************/

#define			TITLE_WINDOW		window( 1,  1, 80,  1 );gotoxy( 1, 1 );

#define			STATUS_TOP										3

#define			NUMBER_OF_STATUS_MONITOR_CUSTOM_ROUTINES		6

#define			OTG_STATUS_WINDOW_HEIGHT						1
#define			DC_PRINTF_AREA_ROWS								3

#define			CURRENT_TIME_DISPLAY

/****************************************************************************/
/*	global vars																*/
/****************************************************************************/


coodinate		Hc_message_coodinate	= { 1, 1 };
coodinate		Dc_message_coodinate	= { 1, 1 };


funcPtr			g_status_monitor_custom_routine[ NUMBER_OF_STATUS_MONITOR_CUSTOM_ROUTINES ] = { NULL, NULL, NULL, NULL, NULL, NULL };

int				g_status_monitor_switch	= 1;
unsigned char	gp_key_polling_flag		= False;
unsigned char	gp_beat_flag				= False;

int				g_window_border			= STATUS_TOP + NUMBER_OF_STATUS_MONITOR_CUSTOM_ROUTINES;
//char			g_msg[]					= "  Philips Semiconductors  ISP1161   USB single-chip Host and Device controller  ";
char			g_msg[]					= "   Philips Semiconductors  ISP1362 : Single Chip USB On-The-Go controller DEMO  ";

unsigned long	gp_debug_test0			= 0;
unsigned long	gp_debug_test1			= 0;


/****************************************************************************/
/*	function prototypes														*/
/****************************************************************************/

void	regster_dump( void );
void	buffer_allocation_info( void );
void	help_messsage( void );
void	version_info( void );
void 	environment_info( void );
void	test_info( void );
void	turn_ON_OFF_vbus( void );
void	suspend_test( void );
void	port_monitor( void );

void	set_status_window( void );
void	set_OTG_status_window( void );
void	set_Dc_window( void );

void	set_message_window( void );

void	screen_title( void );
void	get_cursor_coodinate( coodinate *pos );


/****************************************************************************/
/*	function definitions													*/
/****************************************************************************/





//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


void				transfer_test( void );
transfer_instance	*make_a_transfer( void );
void		  		transfer_done_callback( endpoint_info_ptr epip );

unsigned char		g_buffer_pointer[ 10 ]	= { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
unsigned char		g_transfer_done		= False;


/********************************************************************************************/
/*	Demo routine test harness																*/
/********************************************************************************************/

void transfer_test( void )
{
	transfer_instance	*transfer_inst_pointer;
	
	transfer_inst_pointer		= make_a_transfer();
	
	if ( NULL == transfer_inst_pointer )
	{
		mprintf( WHITE, CONTINUE, "Device not found\r\n" );
		return;
	}
	mprintf( WHITE, CONTINUE, "transfer_test executing\r\n" );

	
	while ( !g_transfer_done )
		/*	Wait until transfer done	*/;	
	
	/*	
	 *	At this moment, you need to check the state of transfer by 
	 *
	 *		transfer_inst_pointer->transferred_size
	 *		transfer_inst_pointer->completion_code		this is copied value of CompletionCode in PTD header
	 *
	 *	See "_hc_core/transfer.h" for more info.
	 */
	
	atlmix_free_transfer( transfer_inst_pointer );		/*	release the slot	*/
	
	return;
}


/********************************************************************************************/
/*	Demonstrate 10 byte bulk-OUT transfer to the device : USB address = 2, Endpoint = 3		*/
/********************************************************************************************/

transfer_instance *make_a_transfer( void )
{
	device_instance		*dev_inst_pointer;
	unsigned char		transfer_slot_index;
	transfer_instance	*transfer_inst_pointer;

	/********************************************/
	/*	Find a device, address = 2				*/
	/********************************************/

	dev_inst_pointer		= devep_find_device( 2 );
	
	if ( NULL == dev_inst_pointer )
		return ( NULL );					/*	No device found		*/


	/********************************************/
	/*	Get a index (reserve transfer slot)		*/
	/********************************************/

	transfer_slot_index		= atlmix_get_open_transfer_index( BULK_TRANSFER );	

	if ( NO_OPEN_ATL_TRANSFER_SLOT == transfer_slot_index )
		return ( NULL );					/*	No open slot		*/

	transfer_inst_pointer	= atlmix_set_transfer(
									BULK_TRANSFER,
									0,
									transfer_slot_index,
									g_buffer_pointer,
									10,
									OUT,
									dev_inst_pointer->epi_ptr[ EpOUT ][ 2 ],
									transfer_done_callback
							);

	return ( transfer_inst_pointer );	/*	Started!	*/
}


/********************************************************************************************/
/*	Callback function for the transfer (called in ISR context)								*/
/********************************************************************************************/

void transfer_done_callback( endpoint_info_ptr dummy )
{
	dummy	= dummy;

	g_transfer_done		= True;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////









/*********															*********/
/*																			*/
/*	Get key input															*/
/*																			*/
/*********															*********/


unsigned char ui_key_polling_timing( void )
{
	unsigned char	flag;
	
	flag				= gp_key_polling_flag;
	gp_key_polling_flag	= False;
	
	return( flag );
}


int ui_key_wait( void )
{
	int		key;

	while ( 1 )
	{
		wait_ms( 0L );
	
		if ( ui_key_polling_timing() )
		{
			if ( hid_usb_key_buffer() )
			{
				key		= hid_usb_key_buffer_pop();
				break;
			}
			else if ( bioskey( 1 ) )
			{
				key		= bioskey( 0 );
				break;
			}
			
			//	Update screen info
			
			ui_status_monitor();
			
			// Poll the event (for topology change event)
			
			portctl_isr_flag_routine_dspatch();
		}
	}

	return ( key );
}


int ui_key_in( void )
{
	int		key;

	if ( hid_usb_key_buffer() )
		key	= hid_usb_key_buffer_pop();
		
	else if ( bioskey( 1 ) )
		key	= bioskey( 0 );
		
	else
		key	= 0;

	return ( key );
}




/*********															*********/
/*																			*/
/*	Functions for getting user commands										*/
/*																			*/
/*********															*********/


unsigned char ui_user_debug_command_key( void )
{

#if 1

	if ( hid_usb_key_buffer() )
		return ( hid_usb_key_buffer_pop() & 0xFF );

	if( bioskey(1) )
		return ( bioskey(0) & 0xFF );

#else

	if ( kbhit() )
		return ( getch() );

#endif	

	return ( 0 );
}


unsigned char ui_user_debug_command_handler( unsigned char command )
{
	int						tmp;
	static unsigned char	quit_flag;
	
	if ( !command )
		return ( 0 );
	
	if ( quit_flag )
		if ( command == 'y' )
			return ( 1 );
		else
		{
			mprintf( LIGHTRED, CONTINUE, "\r\nQuit command cancelled key [0x%02X] '%c' pressed.\r\n", command, command );
			return ( quit_flag	= 0 );
		}
		
	switch( command )
	{
		/********* ********** **********
		**	Basic features
		********** ********** *********/
	
		case 0x1b:  /*	ESC  */
		case 'q':
			if ( !quit_flag )
			{
				quit_flag	= 1;
				mprintf( LIGHTRED, CONTINUE, "\r\nQuit? press [y] >> \r\n" );
			}
			break;
		case 0x0d:  /*	Return  */
			mprintf( LIGHTRED, CONTINUE, "\r\n" );
			break;
			
		case '?':
		case 'h':
			help_messsage();
			break;
			
		case 'v':
			version_info();
			break;
			
		case 'd':
			regster_dump();
			break;
			
		case 'x':
			buffer_allocation_info();
			break;
			
		case ' ':
			ui_show_topology();
			break;
			
		case 'D':
			gp_is_in_DOS_environment		= !gp_is_in_DOS_environment;
			{
				coodinate	pos;
				get_cursor_coodinate( &pos );
	
				screen_title();
				
				set_message_window();
				gotoxy( pos.x, pos.y );
			}
			break;

		case 'e':
			environment_info();
			break;

		case 'i':
			break;

		case 'r':
			mprintf( LIGHTMAGENTA, CONTINUE, "\r\nFORCING RE-CONNECT ROOTHUB PORTS?  [y] for Yes. Other key to cancel. >> " );
			if ( 'y' == (ui_key_wait() & 0xFF) )
			{
				mprintf( LIGHTMAGENTA, CONTINUE, "y" );
				portctl_force_rh_port_reconnect();
				mprintf( LIGHTMAGENTA, CONTINUE, "\r\n  root-hub ports re-connected  \r\n" );
			}
			else
				mprintf( LIGHTMAGENTA, CONTINUE, "\r\n  canceled.  \r\n" );
			break;


		/********* ********** **********
		**	Audio features
		********** ********** *********/
	

		case 'a':
			audio_main( AUDIO_PLAY_MANUAL_SELECTION );
			break;
			
		case 'A':
			audio_main( OTG_AUDIO_SPECIAL_CODE | OTG_AUDIO_MANUAL_SELECTION );
			break;
			
		case 'j':
			audio_sequential_play();
			break;
			
		case ',':
			audio_volume_down();
			break;	
			
		case '.':
			audio_volume_up();
			break;
			
		case 'b':
			beep_warn( 440, 1.00 );
//			beep( 221.50, 0.30, DECAY, POLY );
			break;
			
		case 'Z':
			beep( 440.00 * (12.00 / 10.00) * 1.00, 0.20, SUSTAIN, MONO );
			break;
		case 'X':
			beep( 440.00 * (12.00 / 10.00) * (9.00 / 8.00), 0.20, SUSTAIN, MONO );
			break;
		case 'C':
			beep( 440.00 * (12.00 / 10.00) * (5.00 / 4.00), 0.20, SUSTAIN, MONO );
			break;
		case 'V':
			beep( 440.00 * (12.00 / 10.00) * (4.00 / 3.00), 0.20, SUSTAIN, MONO );
			break;
		case 'B':
			beep( 440.00 * (12.00 / 10.00) * (3.00 / 2.00), 0.20, SUSTAIN, MONO );
			break;
		case 'N':
			beep( 440.00 * (12.00 / 10.00) * (5.00 / 3.00), 0.20, SUSTAIN, MONO );
			break;
		case 'M':
			beep( 440.00 * (12.00 / 10.00) * (15.00 / 8.00), 0.20, SUSTAIN, MONO );
			break;
		case '<':
			beep( 440.00 * (12.00 / 10.00) * 2.00, 0.20, SUSTAIN, MONO );
			break;

			
		/********* ********** **********
		**	Printer features
		********** ********** *********/
	
		case 'p':
			printer_main();
			break;

		/********* ********** **********
		**	Keyboard features
		********** ********** *********/
	
		case 'k':
			hid_keyboard_main();
			break;

		/********* ********** **********
		**	Storage features
		********** ********** *********/
	
		case 's':
			fsts_file_system_test_shell();
			break;


			
		/********* ********** **********
		**	OTG features
		********** ********** *********/
	
		case 'z':
			OTG_bus_request_Toggle();
			break;

		case '/':
			OTG_bus_drop();
			break;

		case 'u':
			OTG_demo_host_side_0();
			break;

		case 'c':
			OTG_demo_host_side_1();
			break;

		case 'f':
			{
				unsigned long	timing_for_set_time;
				time_t			local_time;
			

				local_time	= time( NULL );
				
				while ( local_time == time( NULL ) )
					;

				timing_for_set_time		= gp_sof_counter + 500;
				
				while ( gp_sof_counter < timing_for_set_time )
					;
		
				stime( &local_time );
			}
			break;
			
		case '7' :
			OTG_demo_host_side_7();
			break;
		case '8' :
			OTG_demo_host_side_8();
			break;
		case '9' :
			OTG_demo_host_side_9();
			break;
		case '3' :
			OTG_demo_host_side_3();
			break;


		/********* ********** **********
		**	Experimental features
		********** ********** *********/

#ifdef	PER_PORT_POWER_SWITCHING	//	##	version1.2c (from here)

		case 't' :
			turn_ON_OFF_vbus();
			break;

#endif	// PER_PORT_POWER_SWITCHING	//	##	version1.2c (to here)

		case 'S' :					//	##	version1.2c
			suspend_test();			//	##	version1.2c
			break;					//	##	version1.2c

		case 'l':
//			show_dc_event_log();
			break;

		case 'n':
			if ( gp_beat_flag )
				gp_beat_flag		= False;
			else
				gp_beat_flag		= True;

			break;

		case '-':
			ui_soft_blink( "Philips Semiconductors @Tokyo", 150, 2 );
			break;
		case '+':
			mprintf( WHITE, CONTINUE, "\r\n                 OTG x reg = 0x%04X", read_register16( 0x67 ) & 0x3F );
			break;
//		case '3' :
//			atlmix_view_PTD( 0 );
//			atlmix_view_PTD( 1 );
//			break;

		case '|':
			
			{
				static unsigned short	flag	= 0;
				
				if ( flag )
				{	
					flag	= 0;
					write_register16( Com16_HcHardwareConfiguration, read_register16( Com16_HcHardwareConfiguration ) & ~0x4000 );
				}
				else
				{
					flag	= 1;
					write_register16( Com16_HcHardwareConfiguration, read_register16( Com16_HcHardwareConfiguration ) | 0x4000 );
				}
				mprintf( WHITE, CONTINUE, "\r\nCom16_HcHardwareConfiguration = 0x%04X\r\n", read_register16( Com16_HcHardwareConfiguration ) );
			}
			break;

		case 'o':
			transfer_test();
			mprintf( WHITE, CONTINUE, "\r\n****************transfer test done!\r\n" );
			break;
		default :
			break;
	}
	
	return ( 0 );
}


/*********															*********/
/*																			*/
/*	Display printing/printing area control function							*/
/*																			*/
/*		"mprintf()" and "Dc_printf()" are a feature added "printf()".		*/
/*																			*/
/*********															*********/

#include		<stdarg.h>


void mprintf( unsigned char color, unsigned char mode, char *format, ... )
{
	char		str[ 256 ];
	va_list		args;

	if ( mode == ABORT )
	{
		textattr( LIGHTRED );
		cprintf( "\r\n  * * * ABORTED! * * *\r\n" );
	}

	va_start( args, format );
	
	vsprintf( str, format, args );
	
	textattr( gp_is_in_DOS_environment ? color & 0x7F : color );
	cprintf( str );
//	textattr( 7 );
	
	if ( mode == ABORT )
	{
		ui_status_monitor();
//		regster_dump();

		cprintf( "Press any key" );

		while ( !kbhit() )
			;

		exit ( 1 );
	}
}


void Dc_printf( unsigned char color, unsigned char mode, char *format, ... )
{
#ifdef	DC_PRINTF_DISABLE
#else

#define		CR		0x2
#define		LF		0x1
#define		NON		0x0

	static char				last_line_end	= NON;
	char					curr_line_end	= NON;
	char					*last_char_pos;
	static unsigned short	line_counter	= 0;
	coodinate				pos;
	char					str[ 256 ];
	char					s[ 256 ];
	va_list					args;

	strcpy( s, format );

	get_cursor_coodinate( &pos );
	set_Dc_window();

	gotoxy( Dc_message_coodinate.x, Dc_message_coodinate.y );

	if ( mode == ABORT )
	{
		textattr( LIGHTRED );
		cprintf( "\r\n" );
		cprintf( "  * * * ABORTED! * * *\r\n" );
	}

	va_start( args, format );
	
	vsprintf( str, format, args );
	
	last_char_pos	= (str + strlen(str)) - 1;

	if ( *last_char_pos == '\n' )
	{
		curr_line_end	|= LF;
		last_char_pos--;
	}
	if ( *last_char_pos == '\r' )
	{
		curr_line_end	|= CR;
		last_char_pos--;
	}
	
	*(last_char_pos + 1)	= 0;
	
	textattr( LIGHTGREEN | (GREEN << 4) );
	
	if ( last_line_end & CR )
	{
		cprintf( "\r" );
	}
	if ( last_line_end & LF )
	{
		cprintf( "\n" );
		line_counter++;
	}
	
	if ( last_line_end & CR )
		cprintf( "  DC(%04X)> ", line_counter );

	textattr( (gp_is_in_DOS_environment ? color & 0x7F : color) | (GREEN << 4) );
	cprintf( str );
	textattr( 7 );
	
	last_line_end	= curr_line_end;
	
	Dc_message_coodinate.x	= wherex();
	Dc_message_coodinate.y	= wherey();
	
	set_message_window();
	gotoxy( pos.x, pos.y );

	if ( mode == ABORT )
	{
		ui_status_monitor();
//		regster_dump();
		exit ( 1 );
	}
#endif
}


/*********															*********/
/*																			*/
/*	Screen design															*/
/*																			*/
/*		manages screen areas												*/
/*																			*/
/*********															*********/


void set_status_window( void )
{
	static int		status_left		= 1;
	static int		status_right	= 80;
	static int		status_top		= STATUS_TOP;
	
	window( status_left, status_top, status_right, g_window_border );
	gotoxy( 1, 1 );
}


void set_OTG_status_window( void )
{
	static int		message_left		= 1;
	static int		message_right		= 80;

	window( message_left, g_window_border + 1, message_right, g_window_border + OTG_STATUS_WINDOW_HEIGHT );
}



void set_Dc_window( void )
{
	static int		message_left		= 1;
	static int		message_right		= 80;

	window( message_left, g_window_border + 1 + OTG_STATUS_WINDOW_HEIGHT, message_right, g_window_border + OTG_STATUS_WINDOW_HEIGHT + DC_PRINTF_AREA_ROWS );
}



void set_message_window( void )
{
	static int		message_left		= 1;
	static int		message_right		= 80;
	static int		message_bottom		= 25;
	
	window( message_left, g_window_border + 1 + OTG_STATUS_WINDOW_HEIGHT + DC_PRINTF_AREA_ROWS, message_right, message_bottom );
}


void get_cursor_coodinate( coodinate *pos )
{
	pos->x	= wherex();
	pos->y	= wherey();
}


/*********															*********/
/*																			*/
/*	Screen messege handlers													*/
/*																			*/
/*		Default screen message handling 									*/
/*			and call of custom message in other modules						*/
/*																			*/
/*********															*********/


void ui_status_monitor( void )
{
	coodinate				pos;
	static unsigned char	vital_sign;
	static unsigned char	initial_draw	= 1;
//	static unsigned char	light			= 0;
	unsigned char			i;

	unsigned long			sec;
	unsigned short			frame;
	
#ifdef	CURRENT_TIME_DISPLAY
#else
	static unsigned short	message			= 1;
#endif


	sec			= gp_sof_counter / 1000;
	frame		= gp_sof_counter % 1000;

	if ( !g_status_monitor_switch )
		return;
		
	get_cursor_coodinate( &pos );
	set_status_window();

	if ( initial_draw )
	{
		mprintf( BG_BLUE | WHITE    , CONTINUE, "   HC" );
		mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, " = "   );
		mprintf( BG_BLUE | WHITE    , CONTINUE, "Philips %s", gp_host_name[ gp_chip_version_index ] );

//		mprintf( (vital_sign & 0x1) ? BG_BLUE | LIGHTBLUE : BG_BLUE | YELLOW, CONTINUE, " * " );
		mprintf( (vital_sign & 0x1) ? BG_BLUE | LIGHTBLUE : BG_BLUE | YELLOW, CONTINUE, "   " );
		
		mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, " frame (sec.frm) =%5ld.%03d (0x%08lX)", sec, frame, gp_sof_counter );
		
		initial_draw	= 0;
	}
	else
	{
		gotoxy( 56, 1 );
		mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, "%5ld.%03d (0x%08lX)", sec, frame, gp_sof_counter );
	}
	
	for ( i = 0; i < NUMBER_OF_STATUS_MONITOR_CUSTOM_ROUTINES; i++ )
	{
		if ( NULL != g_status_monitor_custom_routine[ i ] )
		{
			gotoxy( 1, i + 1 );
			(*g_status_monitor_custom_routine[ i ])( i );
		}
	}

//	mprintf( BG_BLUE | LIGHTGRAY, CONTINUE, "\r" );

	set_OTG_status_window();
	OTG_show_port_status();

	set_message_window();
	gotoxy( pos.x, pos.y );

#if 0
	mprintf( (vital_sign++ & 0x1) ? LIGHTBLUE : YELLOW, CONTINUE, " * \r" );
#endif

#if 0
	if ( message & 0x80 )
	{
		gotoxy( (message & 0x7F), wherey() );
		mprintf( BLACK, CONTINUE, " " );
		message		= (message == 0x81) ? 1 : (message - 1);
	}
	else
	{
		gotoxy( message, wherey() );
		mprintf( WHITE, CONTINUE, "%c", g_msg[ message ] );
		message		= (message == 79) ? (0x80 | 72) : (message + 1);
	}
#endif

#if 0
	if ( message & 0x80 )
	{
		gotoxy( (message & 0x7F), wherey() );
		mprintf( BLACK, CONTINUE, " " );
		message		= (message == 0x81) ? 1 : (message - 1);
	}
	else
	{
		gotoxy( message, wherey() );
		mprintf( WHITE, CONTINUE, "%c", g_msg[ message ] );
		message		= (message == 79) ? (0x80 | 79) : (message + 1);
	}
#endif

#ifdef CURRENT_TIME_DISPLAY
//	ui_beat();		//	called from main()
#else
	if ( pos.x == 1 )
		message		= (message & ~0x7F) + (1 << 8) + 1;

	gotoxy( message & 0x7F, wherey() );
	mprintf( ((message >> 8) & 0x1) ? LIGHTGRAY : (LIGHTGRAY | DARKGRAY << 4), CONTINUE, "%c", g_msg[ message & 0x7F ] );
	
	if ((message & 0x7F) == 79)
		message		= (message & ~0x7F) + (1 << 8);
	
	message++;
#endif


#if 0
	griffin_set_parameter( 3, 0 );
	griffin_set_parameter( 1, light += 20 );
#endif

}


extern unsigned char		g_file_read_buffer_IN;
extern unsigned char		g_file_read_buffer_OUT;
extern unsigned char		g_sing_buffer_EMPTY;

unsigned char				g_show_current_time		= True;


void ui_beat( void )
{
#ifdef CURRENT_TIME_DISPLAY

	static time_t			previous_time;
	time_t					current_time;
	char					str[ 64 ];
	
	if ( !g_show_current_time )
		return;
		
	if ( gp_is_in_DOS_environment )
		if ( is_audio_active() && !is_audio_beep_play() )
			return;
	
	current_time	= time( NULL );
	
	if ( previous_time != current_time )
	{
		strftime( str, 64, "%d-%b-%Y %H:%M:%S", localtime( &current_time ) );

		mprintf( LIGHTGRAY, CONTINUE, "  (%s)  \r", str );
//		mprintf( LIGHTGRAY, CONTINUE, "  (%s)  i=0x%08lX i=0x%08lX \r", str, gp_debug_test0, gp_debug_test1 );
//		mprintf( LIGHTGRAY, CONTINUE, "  (%s)  i=0x%04lX  s=0x%04X \r\n", str, gp_debug_test0, read_register16( 0x67 ) );
//		mprintf( LIGHTGRAY, CONTINUE, "  (%s)  0=%lu 1=%lu 2=%lu 3=%lu 4=%lu 5=%lu 6=%lu 7=%lu 8=%lu 9=%lu\r", str, gp_cc_logger[0], gp_cc_logger[1], gp_cc_logger[2], gp_cc_logger[3], gp_cc_logger[4], gp_cc_logger[5], gp_cc_logger[6], gp_cc_logger[7], gp_cc_logger[8], gp_cc_logger[9]  );

		previous_time		= current_time;

		if ( gp_beat_flag )
		{
			switch ( current_time % 10 )
			{
				case 7 :
				case 8 :
				case 9 :
					beep( 440.00, 0.10, SUSTAIN, MONO );
					break;
				case 0 :
					beep( 880.00, 1.00, DECAY, MONO );
					break;
				default :
					break;
			}
		}
	}
#endif	//	CURRENT_TIME_DISPLAY
}


void ui_show_current_time( unsigned char flag )
{
	g_show_current_time		= flag;
}


void ui_install_status_monitor_custom_routine( unsigned char number, void (*custom_monitor)( unsigned char dummy ) )
{
	coodinate	pos;
	funcPtr		tmp;
	int			i;
	
	if ( !(number < NUMBER_OF_STATUS_MONITOR_CUSTOM_ROUTINES) )
	{
		mprintf( YELLOW, CONTINUE, "ui_install_status_monitor_custom_routine=%p @%d\r\n", custom_monitor, number );
		mprintf( LIGHTRED, ABORT, "error @ ui_install_status_monitor_custom_routine\r\n" );
	}
	
	get_cursor_coodinate( &pos );
	set_status_window();
	
	gotoxy( 1, number + 1 );
	
	mprintf( BG_BLUE | BLACK, CONTINUE, "\r" );

	for ( i = 0; i < 79; i++ )
		mprintf( BG_BLUE | BLACK, CONTINUE, " " );

	mprintf( BG_BLUE | BLACK, CONTINUE, "\r" );

	set_message_window();
	gotoxy( pos.x, pos.y );

	g_status_monitor_custom_routine[ number ]	= custom_monitor;
}


/*********															*********/
/*																			*/
/*	Screen messege															*/
/*																			*/
/*		Screen messages					 									*/
/*																			*/
/*********															*********/


void ui_isr_flag_monitor( void )
{
	unsigned short	flag_mask;	/*  this mask shold be set to */

	flag_mask	= SOFISTLInt | ATL_IRQ | AllEOTInterrupt;

	if ( !(gp_isr_flag & ~flag_mask) )
		return;
	
	mprintf( LIGHTGREEN, CONTINUE, "\r\n" );

	if ( gp_isr_flag & SOFISTLInt )			mprintf( LIGHTGREEN, CONTINUE, "    SOFISTLInt \r\n" );
	if ( gp_isr_flag & ISTL_0_Int )			mprintf( LIGHTGREEN, CONTINUE, "    ISTL_0_Int \r\n" );
	if ( gp_isr_flag & ISTL_1_Int )			mprintf( LIGHTGREEN, CONTINUE, "    ISTL_1_Int \r\n" );
	if ( gp_isr_flag & AllEOTInterrupt )		mprintf( LIGHTGREEN, CONTINUE, "    AllEOTInterrupt \r\n" );
	if ( gp_isr_flag & HCSuspend )			mprintf( LIGHTGREEN, CONTINUE, "    HCSuspend \r\n" );
	if ( gp_isr_flag & ClkReady )			mprintf( LIGHTGREEN, CONTINUE, "    ClkReady \r\n" );
	if ( gp_isr_flag & INT_IRQ )				mprintf( LIGHTGREEN, CONTINUE, "    INT_IRQ \r\n" );
	if ( gp_isr_flag & ATL_IRQ )				mprintf( LIGHTGREEN, CONTINUE, "    ATL_IRQ \r\n" );
	if ( gp_isr_flag & OTG_IRQ )				mprintf( LIGHTGREEN, CONTINUE, "    OTG_IRQ \r\n" );
	if ( gp_isr_flag & OPR_Reg )				mprintf( LIGHTGREEN, CONTINUE, "    OPR_Reg...\r\n" );
	if ( gp_isr_flag & SO )					mprintf( LIGHTGREEN, CONTINUE, "              -> SO \r\n" );
	if ( gp_isr_flag & SF )					mprintf( LIGHTGREEN, CONTINUE, "              -> SF \r\n" );
	if ( gp_isr_flag & RD )					mprintf( LIGHTGREEN, CONTINUE, "              -> RD \r\n" );
	if ( gp_isr_flag & UE )					mprintf( LIGHTGREEN, CONTINUE, "              -> UE \r\n" );
	if ( gp_isr_flag & FNO )					mprintf( LIGHTGREEN, CONTINUE, "              -> FNO \r\n" );
	if ( gp_isr_flag & RHSC )				mprintf( LIGHTGREEN, CONTINUE, "              -> RHSC \r\n" );

	mprintf( LIGHTGRAY, CONTINUE, "\r" );
}


void ui_start_message( void )
{
	int		i;
	
	clrscr();

	window( 1, 1, 80, g_window_border );
	gotoxy( 1, 1 );
	
	textbackground( BLUE );

	for ( i = 0; i < 800; i++ )
		mprintf( BG_BLUE | WHITE, CONTINUE, " " );



	set_OTG_status_window();
	gotoxy( 1, 1 );
	textbackground( YELLOW );
	for ( i = 0; i < 40; i++ )
		mprintf( BROWN << 4 | BROWN, CONTINUE, " " );


	set_Dc_window();
	gotoxy( 1, 1 );
	textbackground( GREEN );
	for ( i = 0; i < 400; i++ )
		mprintf( GREEN << 4 | GREEN, CONTINUE, " " );

	screen_title();
	
	set_message_window();

	gotoxy( 1, 1 );

	mprintf( LIGHTBLUE, CONTINUE,"\r\n");
	mprintf( LIGHTBLUE, CONTINUE,"\r\n");
	mprintf( LIGHTBLUE, CONTINUE," *****************************************************************************\r\n");
	mprintf( LIGHTBLUE, CONTINUE," ******************               ");
	mprintf( WHITE,     CONTINUE,                                  "WASABI-Hot! ");
	mprintf( LIGHTBLUE, CONTINUE,                                              "              ******************\r\n");
	mprintf( LIGHTBLUE, CONTINUE," ******************        ");
	mprintf( LIGHTGRAY, CONTINUE,                           "version %s (%s)", VERSION_NUMBER, __DATE__ );
	mprintf( LIGHTBLUE, CONTINUE,                                                     "       ******************\r\n");
//	mprintf( LIGHTBLUE, CONTINUE,"               ****                                         ****\r\n");
	mprintf( LIGHTBLUE, CONTINUE," ******************                                         ******************\r\n");
	mprintf( LIGHTBLUE, CONTINUE," ******************      ");
	mprintf( LIGHTCYAN, CONTINUE,                         "Philips Semiconductors, Tokyo");
	mprintf( LIGHTBLUE, CONTINUE,                                                      "      ******************\r\n");
	mprintf( LIGHTBLUE, CONTINUE," *****************************************************************************\r\n");
	mprintf( LIGHTBLUE, CONTINUE,"                         build : %s  %s\r\n", __DATE__, __TIME__ );


#ifdef COLORSCALE
	mprintf( LIGHTGRAY, CONTINUE, "                                " );
	
	for ( i = 0; i < 16; i++ )
	{
		mprintf( i, CONTINUE, "%X", i  );
	}
	mprintf( LIGHTGRAY, CONTINUE,"\r\n");
	mprintf( LIGHTGRAY, CONTINUE,"\r\n");
#endif

}

void screen_title( void )
{
	TITLE_WINDOW
	
	gotoxy( 1, 1 );

	mprintf( (WHITE << 4) | WHITE, CONTINUE, "\r\n" );
		
	mprintf( (WHITE << 4) | BLACK,    CONTINUE,    "  WASABI-" );
	mprintf( (WHITE << 4) | LIGHTRED, CONTINUE,    "Hot!" );
	mprintf( (WHITE << 4) | BLACK,    CONTINUE,    " version %s (build : %s)  Philips Semiconductors, Tokyo", VERSION_NUMBER, __DATE__ );
}


void regster_dump( void )
{
	mprintf( LIGHTGREEN, CONTINUE, "\r\nHc register dump\r\n" );

	mprintf( LIGHTBLUE , CONTINUE, "  HcRevision         (0x%02X): 0x%08lX",         Com32_HcRevision,               read_register32( Com32_HcRevision              ) );
	mprintf( WHITE     , CONTINUE, "  HcHardwareConfiguration(0x%02X): 0x%04X\r\n",  Com16_HcHardwareConfiguration,  read_register16( Com16_HcHardwareConfiguration ) );
	mprintf( LIGHTBLUE , CONTINUE, "  HcControl          (0x%02X): 0x%08lX",         Com32_HcControl,                read_register32( Com32_HcControl               ) );
	mprintf( WHITE     , CONTINUE, "  HcDMAConfiguration     (0x%02X): 0x%04X\r\n",  Com16_HcDMAConfiguration,       read_register16( Com16_HcDMAConfiguration      ) );
	mprintf( LIGHTBLUE , CONTINUE, "  HcCommandStatus    (0x%02X): 0x%08lX",         Com32_HcCommandStatus,          read_register32( Com32_HcCommandStatus         ) );
	mprintf( WHITE     , CONTINUE, "  HcTransferCounter      (0x%02X): 0x%04X\r\n",  Com16_HcTransferCounter,        read_register16( Com16_HcTransferCounter       ) );
	mprintf( LIGHTBLUE , CONTINUE, "  HcInterruptStatus  (0x%02X): 0x%08lX",         Com32_HcInterruptStatus,        read_register32( Com32_HcInterruptStatus       ) );
	mprintf( WHITE     , CONTINUE, "  HcuPInterrupt          (0x%02X): 0x%04X\r\n",  Com16_HcuPInterrupt,            read_register16( Com16_HcuPInterrupt           ) );
	mprintf( LIGHTBLUE , CONTINUE, "  HcInterruptEnable  (0x%02X): 0x%08lX",         Com32_HcInterruptEnable,        read_register32( Com32_HcInterruptEnable       ) );
	mprintf( WHITE     , CONTINUE, "  HcuPInterruptEnable    (0x%02X): 0x%04X\r\n",  Com16_HcuPInterruptEnable,      read_register16( Com16_HcuPInterruptEnable     ) );
	mprintf( LIGHTBLUE , CONTINUE, "  HcInterruptDisable (0x%02X): 0x%08lX",         Com32_HcInterruptDisable,       read_register32( Com32_HcInterruptDisable      ) );
	mprintf( WHITE     , CONTINUE, "  HcChipID               (0x%02X): 0x%04X\r\n",  Com16_HcChipID,                 read_register16( Com16_HcChipID                ) & (gp_version_display ? 0xFFFF : 0xFFF0) );
	
	mprintf( LIGHTGREEN, CONTINUE, "  HcFmInterval       (0x%02X): 0x%08lX",         Com32_HcFmInterval,             read_register32( Com32_HcFmInterval            ) );
	mprintf( WHITE     , CONTINUE, "  HcScratch              (0x%02X): 0x%04X\r\n",  Com16_HcScratch,                read_register16( Com16_HcScratch               ) );
	mprintf( LIGHTGREEN, CONTINUE, "  HcFmRemaining      (0x%02X): 0x%08lX",         Com32_HcFmRemaining,            read_register32( Com32_HcFmRemaining           ) );
	mprintf( WHITE     , CONTINUE, "  HcSoftwareReset        (0x%02X): N/A   \r\n",  Com16_HcSoftwareReset );
	mprintf( LIGHTGREEN, CONTINUE, "  HcFmNumber         (0x%02X): 0x%08lX",         Com32_HcFmNumber,               read_register32( Com32_HcFmNumber              ) );
	mprintf( WHITE     , CONTINUE, "\r\n" );
	mprintf( LIGHTGREEN, CONTINUE, "  HcLSThreshold      (0x%02X): 0x%08lX",         Com32_HcLSThreshold,            read_register32( Com32_HcLSThreshold           ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcRhStatus         (0x%02X): 0x%08lX\r\n",     Com32_HcRhStatus,               read_register32( Com32_HcRhStatus              ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcRhDescriptorA    (0x%02X): 0x%08lX",         Com32_HcRhDescriptorA,          read_register32( Com32_HcRhDescriptorA         ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcRhPortStatus1    (0x%02X): 0x%08lX\r\n",     Com32_HcRhPortStatus1,          read_register32( Com32_HcRhPortStatus1         ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcRhDescriptorB    (0x%02X): 0x%08lX",         Com32_HcRhDescriptorB,          read_register32( Com32_HcRhDescriptorB         ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcRhPortStatus2    (0x%02X): 0x%08lX",         Com32_HcRhPortStatus2,          read_register32( Com32_HcRhPortStatus2         ) );

	mprintf( YELLOW, CONTINUE, "\r\n    press key to continue... (ESC for cancel)\r" );
	
	if ( 0x1b == ui_key_wait() & 0xFF )
		return;

	mprintf( WHITE     , CONTINUE, "\r\n" );
	mprintf( WHITE     , CONTINUE, "  HcBufferStatus (0x%02X): 0x%04X",             Com16_HcBufferStatus,        read_register16( Com16_HcBufferStatus        ) );
	mprintf( WHITE     , CONTINUE, "  HcDirectAddressLength (0x%02X): 0x%08lX\r\n", Com32_HcDirectAddressLength, read_register32( Com32_HcDirectAddressLength ) );
	mprintf( WHITE     , CONTINUE, "\r\n" );

	mprintf( LIGHTBLUE , CONTINUE, "  HcISTLBufferSize (0x%02X): 0x%04X",           Com16_HcISTLBufferSize,      read_register16( Com16_HcISTLBufferSize       ) );
	mprintf( LIGHTGREEN, CONTINUE, "    HcINTLPTDDoneMap (0x%02X): 0x%08lX\r\n",    Com32_HcINTLPTDDoneMap,      read_register32( Com32_HcINTLPTDDoneMap ) );
	mprintf( LIGHTBLUE , CONTINUE, "  HcISTL0BufferPort(0x%02X):   ----",           Com16_HcISTL0BufferPort );
	mprintf( LIGHTGREEN, CONTINUE, "    HcINTLPTDSkipMap (0x%02X): 0x%08lX\r\n",    Com32_HcINTLPTDSkipMap,      read_register32( Com32_HcINTLPTDSkipMap ) );
	mprintf( LIGHTBLUE , CONTINUE, "  HcISTL1BufferPort(0x%02X):   ----",           Com16_HcISTL1BufferPort );
	mprintf( LIGHTGREEN, CONTINUE, "    HcINTLLastPTD    (0x%02X): 0x%08lX\r\n",    Com32_HcINTLLastPTD,         read_register32( Com32_HcINTLLastPTD    ) );
	mprintf( LIGHTBLUE , CONTINUE, "  HcISTLToggleRate (0x%02X): 0x%04X",           Com16_HcISTLToggleRate,      read_register16( Com16_HcISTLToggleRate       ) );
	mprintf( LIGHTGREEN, CONTINUE, "    HcINTLBufferSize (0x%02X): 0x%04X\r\n",     Com16_HcINTLBufferSize,      read_register16( Com16_HcINTLBufferSize       ) );
	mprintf( LIGHTGREEN, CONTINUE, "                                 " );
	mprintf( LIGHTGREEN, CONTINUE, "    HcINTLBufferPort (0x%02X):   ----\r\n",     Com16_HcINTLBufferPort );
	mprintf( LIGHTCYAN , CONTINUE, "  HcATLBufferSize(0x%02X): 0x%04X",           Com16_HcATLBufferSize,       read_register16( Com16_HcATLBufferSize       ) );
	mprintf( LIGHTGREEN, CONTINUE, "      HcINTLBlkSize    (0x%02X): 0x%04X\r\n",     Com16_HcINTLBlkSize,         read_register16( Com16_HcINTLBlkSize       ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcATLBufferPort(0x%02X):   ----",           Com16_HcATLBufferPort  );
	mprintf( LIGHTGREEN, CONTINUE, "      HcINTLCurrActPTD (0x%02X): 0x%04X\r\n",     Com16_HcINTLCurrentActiePTD, read_register16( Com16_HcINTLCurrentActiePTD       ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcATLBlkSize   (0x%02X): 0x%04X\r\n",       Com16_HcATLBlkSize,          read_register16( Com16_HcATLBlkSize       ) );

	mprintf( LIGHTCYAN , CONTINUE, "  HcATLPTDDoneMap(0x%02X): 0x%08lX", Com32_HcATLPTDDoneMap,            read_register32( Com32_HcATLPTDDoneMap  ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcATLCurrActPTD             (0x%02X): 0x%04X\r\n",             Com16_HcATLCurrentActiePTD,         read_register16( Com16_HcATLCurrentActiePTD       ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcATLPTDSkipMap(0x%02X): 0x%08lX", Com32_HcATLPTDSkipMap,            read_register32( Com32_HcATLPTDSkipMap  ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcATLPTDDoneThresholdCount  (0x%02X): 0x%04X\r\n", Com16_HcATLPTDDoneThresholdCount,   read_register16( Com16_HcATLPTDDoneThresholdCount   ) );
	mprintf( LIGHTCYAN , CONTINUE, "  HcATLLastPTD   (0x%02X): 0x%08lX", Com32_HcATLLastPTD,               read_register32( Com32_HcATLLastPTD     ) );

	mprintf( LIGHTCYAN , CONTINUE, "  HcATLPTDDoneThresholdTimeOut(0x%02X): ", Com16_HcATLPTDDoneThresholdTimeOut );
	mprintf( LIGHTCYAN , CONTINUE, "0x%04X\r\n", read_register16( Com16_HcATLPTDDoneThresholdTimeOut ) );

}


void buffer_allocation_info( void )
{
	unsigned short	istl_sz;
	unsigned short	intl_sz;
	unsigned short	atl_sz;
	
	istl_sz		= read_register16( Com16_HcISTLBufferSize );
	intl_sz		= read_register16( Com16_HcINTLBufferSize );
	atl_sz		= read_register16( Com16_HcATLBufferSize  );
	
	istl_sz		<<= 1;

	mprintf( LIGHTGREEN, CONTINUE, "\r\n\r\nHc buffer allocation info\r\n" );

	mprintf( LIGHTGRAY, CONTINUE, "  ISTL (Buffer for isochronous transfer)  %4u bytes (%5.2f%%)\r\n", istl_sz, (istl_sz / 4096.0) * 100.0 );
	mprintf( LIGHTGRAY, CONTINUE, "  INTL (Buffer for interrupt transfer)    %4u bytes (%5.2f%%)\r\n", intl_sz, (intl_sz / 4096.0) * 100.0 );
	mprintf( LIGHTGRAY, CONTINUE, "  ATL  (Buffer for aperiodic transfer)    %4u bytes (%5.2f%%)\r\n", atl_sz,  (atl_sz  / 4096.0) * 100.0 );

	mprintf( LIGHTGREEN, CONTINUE, "\r\n" );
}


void ui_soft_blink( char *s, unsigned short interval, unsigned char repeat )
{
	unsigned short	i;
	unsigned char	scale[ 6 ]	= { DARKGRAY, LIGHTGRAY, WHITE, LIGHTGRAY, DARKGRAY, BLACK };
	
	for ( i = 0; i < (repeat * 6); i++ )
	{
		mprintf( scale[ i % 6 ], CONTINUE, "%s\r", s );
		wait_ms( interval );
	}
}

void ui_print_unicode( unsigned char color, unsigned short *str )
{
	char	buff[ 128 ];
	int		i;
	
	ui_unicode_to_C_string( buff, str + 1, (((std_string_descriptor *)str)->bLength) >> 1 );

	mprintf( color, CONTINUE, buff );
}


int ui_unicode_to_C_string( char *target, unsigned short *source, int length )
{
	int		i;
	
	for ( i = 0; i < (length - 1); i++ )
		*target++		= (char)(*source++);
	
	*target		= '\0';
	
	return ( i );
}


void ui_show_device_string_descriptors( device_instance *dp )
{
	mprintf( LIGHTGRAY, CONTINUE, "    - manufacturer : " );

	if ( dp->string_manufacturer != NULL )
		ui_print_unicode( LIGHTGRAY, dp->string_manufacturer );
	else
		mprintf( LIGHTGRAY, CONTINUE, "   ---   (N/A)" );
		
	mprintf( LIGHTGRAY, CONTINUE, "\r\n    - product      : " );

	if ( dp->string_product != NULL )
		ui_print_unicode( LIGHTGRAY, dp->string_product );
	else
		mprintf( LIGHTGRAY, CONTINUE, "   ---   (N/A)" );
		

	mprintf( LIGHTGRAY, CONTINUE, "\r\n    - serial #     : " );

	if ( dp->string_serialNum != NULL )
		ui_print_unicode( LIGHTGRAY, dp->string_serialNum );
	else
		mprintf( LIGHTGRAY, CONTINUE, "   ---   (N/A)" );

	mprintf( LIGHTGRAY, CONTINUE, "\r\n" );
}


void ui_device_infomation_viewer( device_instance *dp )
{
	int					i;
	endpoint_info		*epp;

	mprintf( LIGHTGREEN, CONTINUE, "device instance pointer %p\r\n", dp );
	mprintf( LIGHTGREEN, CONTINUE, "  address 0x%02X\r\n", dp->address );
	mprintf( LIGHTGREEN, CONTINUE, "  speed   0x%02X\r\n", dp->speed );
	
	mprintf( LIGHTGREEN, CONTINUE, "  string_manufacturer   %p\r\n", dp->string_manufacturer );
	if (  dp->string_manufacturer )
		ui_print_unicode( LIGHTGRAY, dp->string_manufacturer );
	mprintf( LIGHTGREEN, CONTINUE, "\r\n" );
	
	mprintf( LIGHTGREEN, CONTINUE, "  string_product   %p\r\n", dp->string_product );
	if (  dp->string_product )
		ui_print_unicode( LIGHTGRAY, dp->string_product );
	mprintf( LIGHTGREEN, CONTINUE, "\r\n" );
		
	mprintf( LIGHTGREEN, CONTINUE, "  string_serialNum   %p\r\n", dp->string_serialNum );
	if (  dp->string_serialNum )
		ui_print_unicode( LIGHTGRAY, dp->string_serialNum );
	mprintf( LIGHTGREEN, CONTINUE, "\r\n" );
		
	mprintf( LIGHTGREEN, CONTINUE, "  dev_descriptor pointer %p\r\n", &(dp->dev_descriptor) );
	mprintf( LIGHTGREEN, CONTINUE, "    bLength            0x%02X\r\n", (dp->dev_descriptor).bLength );
	mprintf( LIGHTGREEN, CONTINUE, "    bDescriptorType    0x%02X\r\n", (dp->dev_descriptor).bDescriptorType );
	mprintf( LIGHTGREEN, CONTINUE, "    bcdUSB             0x%04X\r\n", (dp->dev_descriptor).bcdUSB );
	mprintf( LIGHTGREEN, CONTINUE, "    bDeviceClass       0x%02X\r\n", (dp->dev_descriptor).bDeviceClass );
	mprintf( LIGHTGREEN, CONTINUE, "    bDeviceSubClass    0x%02X\r\n", (dp->dev_descriptor).bDeviceSubClass );
	mprintf( LIGHTGREEN, CONTINUE, "    bDeviceProtocol    0x%02X\r\n", (dp->dev_descriptor).bDeviceProtocol );
	mprintf( LIGHTGREEN, CONTINUE, "    bMaxPacketSize0    0x%02X\r\n", (dp->dev_descriptor).bMaxPacketSize0 );
	mprintf( LIGHTGREEN, CONTINUE, "    idVendor           0x%04X\r\n", (dp->dev_descriptor).idVendor );
	mprintf( LIGHTGREEN, CONTINUE, "    idProduct          0x%04X\r\n", (dp->dev_descriptor).idProduct );
	mprintf( LIGHTGREEN, CONTINUE, "    bcdDevice          0x%04X\r\n", (dp->dev_descriptor).bcdDevice );
	mprintf( LIGHTGREEN, CONTINUE, "    iManufacturer      0x%02X\r\n", (dp->dev_descriptor).iManufacturer );
	mprintf( LIGHTGREEN, CONTINUE, "    iProduct           0x%02X\r\n", (dp->dev_descriptor).iProduct );
	mprintf( LIGHTGREEN, CONTINUE, "    iSerialNumber      0x%02X\r\n", (dp->dev_descriptor).iSerialNumber );
	mprintf( LIGHTGREEN, CONTINUE, "    bNumConfigurations 0x%02X\r\n", (dp->dev_descriptor).bNumConfigurations );
		mprintf( LIGHTGREEN, CONTINUE, "press key to see more.\r" );
		ui_key_wait();
		mprintf( LIGHTGREEN, CONTINUE, "p\r" );
		
		
	mprintf( LIGHTGREEN, CONTINUE, "  dev_descriptor (conf) pointer %p\r\n", &(dp->conf_descriptor) );
	mprintf( LIGHTGREEN, CONTINUE, "    bLength            0x%02X\r\n", (dp->conf_descriptor).bLength );
	mprintf( LIGHTGREEN, CONTINUE, "    bDescriptorType    0x%02X\r\n", (dp->conf_descriptor).bDescriptorType );
	mprintf( LIGHTGREEN, CONTINUE, "    wTotalLength       0x%04X\r\n", (dp->conf_descriptor).wTotalLength );
	mprintf( LIGHTGREEN, CONTINUE, "    bNumInterfaces     0x%02X\r\n", (dp->conf_descriptor).bNumInterfaces );
	mprintf( LIGHTGREEN, CONTINUE, "    bConfigurationValue 0x%02X\r\n", (dp->conf_descriptor).bConfigurationValue );
	mprintf( LIGHTGREEN, CONTINUE, "    iConfiguration     0x%02X\r\n", (dp->conf_descriptor).iConfiguration );
	mprintf( LIGHTGREEN, CONTINUE, "    bmAttributes       0x%02X\r\n", (dp->conf_descriptor).bmAttributes );
	mprintf( LIGHTGREEN, CONTINUE, "    bMaxPower          0x%02X\r\n", (dp->conf_descriptor).bMaxPower );
		mprintf( LIGHTGREEN, CONTINUE, "press key to see more.\r" );
		ui_key_wait();
		mprintf( LIGHTGREEN, CONTINUE, "p\r" );
		
		
	mprintf( LIGHTGREEN, CONTINUE, "  interfacef_descriptor pointer %p\r\n", &(dp->interfacef_descriptor) );
	mprintf( LIGHTGREEN, CONTINUE, "    bLength            0x%02X\r\n", (dp->interfacef_descriptor).bLength );
	mprintf( LIGHTGREEN, CONTINUE, "    bDescriptorType    0x%02X\r\n", (dp->interfacef_descriptor).bDescriptorType );
	mprintf( LIGHTGREEN, CONTINUE, "    bInterfaceNumber   0x%02X\r\n", (dp->interfacef_descriptor).bInterfaceNumber );
	mprintf( LIGHTGREEN, CONTINUE, "    bAlternateSetting  0x%02X\r\n", (dp->interfacef_descriptor).bAlternateSetting );
	mprintf( LIGHTGREEN, CONTINUE, "    bNumEndpoints      0x%02X\r\n", (dp->interfacef_descriptor).bNumEndpoints );
	mprintf( LIGHTGREEN, CONTINUE, "    bInterfaceClass    0x%02X\r\n", (dp->interfacef_descriptor).bInterfaceClass );
	mprintf( LIGHTGREEN, CONTINUE, "    bInterfaceSubClass 0x%02X\r\n", (dp->interfacef_descriptor).bInterfaceSubClass );
	mprintf( LIGHTGREEN, CONTINUE, "    bInterfaceProtocol 0x%02X\r\n", (dp->interfacef_descriptor).bInterfaceProtocol );
	mprintf( LIGHTGREEN, CONTINUE, "    iInterface         0x%02X\r\n", (dp->interfacef_descriptor).iInterface );
		mprintf( LIGHTGREEN, CONTINUE, "press key to see more.\r" );
		ui_key_wait();
		mprintf( LIGHTGREEN, CONTINUE, "p\r" );


	for ( i = 0; i < MAX_ENDPOINT_NUM; i++ )
	{
		epp		= dp->epi_ptr[ EpOUT ][ i ];
		
		mprintf( LIGHTGREEN, CONTINUE, "  endpoint[ EpOUT ][ %d ] %p\r\n", i, epp );
		
//		if ( epp == NULL )
//			continue;

		if ( epp != NULL )
		{
			mprintf( LIGHTGREEN, CONTINUE, "    max_packet_size      0x%04X\r\n", (epp->max_packet_size) );
			mprintf( LIGHTGREEN, CONTINUE, "    dev_addr             0x%02X\r\n", (epp->dev_addr) );
			mprintf( LIGHTGREEN, CONTINUE, "    ep_num               0x%02X\r\n", (epp->ep_num) );
			mprintf( LIGHTGREEN, CONTINUE, "    toggle               0x%02X\r\n", (epp->toggle) );
			mprintf( LIGHTGREEN, CONTINUE, "    speed                0x%02X\r\n", (epp->speed) );
			mprintf( LIGHTGREEN, CONTINUE, "    direction            0x%02X\r\n", (epp->direction) );
			mprintf( LIGHTGREEN, CONTINUE, "    tr_type              0x%02X\r\n", (epp->tr_type) );
			mprintf( LIGHTGREEN, CONTINUE, "    transfer_type        0x%02X\r\n", (epp->transfer_type) );
			mprintf( LIGHTGREEN, CONTINUE, "    endpoint_descriptor pointer ep-index[ %d ] %p\r\n", i, &(epp->endpoint_descriptor) );
			mprintf( LIGHTGREEN, CONTINUE, "      bLength            0x%02X\r\n", (epp->endpoint_descriptor).bLength );
			mprintf( LIGHTGREEN, CONTINUE, "      bDescriptorType    0x%02X\r\n", (epp->endpoint_descriptor).bDescriptorType );
			mprintf( LIGHTGREEN, CONTINUE, "      bEndpointAddress   0x%02X\r\n", (epp->endpoint_descriptor).bEndpointAddress );
			mprintf( LIGHTGREEN, CONTINUE, "      bmAttributes       0x%02X\r\n", (epp->endpoint_descriptor).bmAttributes );
			mprintf( LIGHTGREEN, CONTINUE, "      wMaxPacketSize     0x%04X\r\n", (epp->endpoint_descriptor).wMaxPacketSize );
			mprintf( LIGHTGREEN, CONTINUE, "      bInterval          0x%02X\r\n", (epp->endpoint_descriptor).bInterval );
				mprintf( LIGHTGREEN, CONTINUE, "press key to see more.\r" );
				ui_key_wait();
				mprintf( LIGHTGREEN, CONTINUE, "p\r" );
		}
	}							
	for ( i = 0; i < MAX_ENDPOINT_NUM; i++ )
	{
		epp		= dp->epi_ptr[ EpIN ][ i ];
		
		mprintf( LIGHTGREEN, CONTINUE, "  endpoint[ EpIN  ][ %d ] %p\r\n", i, epp );
		
//		if ( epp == NULL )
//			continue;

		if ( epp != NULL )
		{
			mprintf( LIGHTGREEN, CONTINUE, "    max_packet_size      0x%04X\r\n", (epp->max_packet_size) );
			mprintf( LIGHTGREEN, CONTINUE, "    dev_addr             0x%02X\r\n", (epp->dev_addr) );
			mprintf( LIGHTGREEN, CONTINUE, "    ep_num               0x%02X\r\n", (epp->ep_num) );
			mprintf( LIGHTGREEN, CONTINUE, "    toggle               0x%02X\r\n", (epp->toggle) );
			mprintf( LIGHTGREEN, CONTINUE, "    speed                0x%02X\r\n", (epp->speed) );
			mprintf( LIGHTGREEN, CONTINUE, "    direction            0x%02X\r\n", (epp->direction) );
			mprintf( LIGHTGREEN, CONTINUE, "    tr_type              0x%02X\r\n", (epp->tr_type) );
			mprintf( LIGHTGREEN, CONTINUE, "    transfer_type        0x%02X\r\n", (epp->transfer_type) );
			mprintf( LIGHTGREEN, CONTINUE, "    endpoint_descriptor pointer ep-index[ %d ] %p\r\n", i, &(epp->endpoint_descriptor) );
			mprintf( LIGHTGREEN, CONTINUE, "      bLength            0x%02X\r\n", (epp->endpoint_descriptor).bLength );
			mprintf( LIGHTGREEN, CONTINUE, "      bDescriptorType    0x%02X\r\n", (epp->endpoint_descriptor).bDescriptorType );
			mprintf( LIGHTGREEN, CONTINUE, "      bEndpointAddress   0x%02X\r\n", (epp->endpoint_descriptor).bEndpointAddress );
			mprintf( LIGHTGREEN, CONTINUE, "      bmAttributes       0x%02X\r\n", (epp->endpoint_descriptor).bmAttributes );
			mprintf( LIGHTGREEN, CONTINUE, "      wMaxPacketSize     0x%04X\r\n", (epp->endpoint_descriptor).wMaxPacketSize );
			mprintf( LIGHTGREEN, CONTINUE, "      bInterval          0x%02X\r\n", (epp->endpoint_descriptor).bInterval );
				mprintf( LIGHTGREEN, CONTINUE, "press key to see more.\r" );
				ui_key_wait();
				mprintf( LIGHTGREEN, CONTINUE, "p\r" );
		}
	}							
}


void help_messsage( void )
{
	clrscr();

	mprintf( LIGHTGRAY, CONTINUE, "    Help info: Key commands\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "    ^^^^^^^^^^^^^^^^^^^^^^^\r\n" );

	mprintf( LIGHTGRAY, CONTINUE, "    " );
	mprintf( YELLOW  , CONTINUE, "[a]" );
	mprintf( LIGHTGRAY, CONTINUE, " Audio play                       " );

	mprintf( YELLOW  , CONTINUE, "[q]" );
	mprintf( LIGHTGRAY, CONTINUE, " or " );
	mprintf( YELLOW  , CONTINUE, "[Esc]" );
	mprintf( LIGHTGRAY, CONTINUE, " Quit\r\n" );


	mprintf( LIGHTGRAY, CONTINUE, "    " );
	mprintf( YELLOW  , CONTINUE, "[j]" );
	mprintf( LIGHTGRAY, CONTINUE, " Jukebox mode (Repeat musics)     " );

	mprintf( YELLOW  , CONTINUE, "[Space]" );
	mprintf( LIGHTGRAY, CONTINUE, "  Show bus topology\r\n" );


	mprintf( LIGHTGRAY, CONTINUE, "    " );
	mprintf( YELLOW  , CONTINUE, "[b]" );
	mprintf( LIGHTGRAY, CONTINUE, " Play Beep                        " );

	mprintf( YELLOW  , CONTINUE, "[e]" );
	mprintf( LIGHTGRAY, CONTINUE, "  Environmental information\r\n" );


	mprintf( LIGHTGRAY, CONTINUE, "    " );
	mprintf( YELLOW  , CONTINUE, "[p]" );
	mprintf( LIGHTGRAY, CONTINUE, " Printer operation                " );

	mprintf( YELLOW  , CONTINUE, "[v]" );
	mprintf( LIGHTGRAY, CONTINUE, " Version information\r\n" );

	mprintf( LIGHTGRAY, CONTINUE, "    " );
	mprintf( YELLOW  , CONTINUE, "[k]" );
	mprintf( LIGHTGRAY, CONTINUE, " Keyboard input test              " );

	mprintf( YELLOW  ,  CONTINUE, "[?]" );
	mprintf( LIGHTGRAY, CONTINUE, " or " );
	mprintf( YELLOW  ,  CONTINUE, "[h]" );
	mprintf( LIGHTGRAY, CONTINUE, " Help information\r\n" );


	mprintf( LIGHTGRAY, CONTINUE, "    " );
	mprintf( YELLOW  ,  CONTINUE, "[d]" );
	mprintf( LIGHTGRAY, CONTINUE, " Hc register dump                 " );

	mprintf( YELLOW  ,  CONTINUE, "[r]" );
	mprintf( LIGHTGRAY, CONTINUE, " Force reconnect RH port devices\r\n" );


	mprintf( LIGHTGRAY, CONTINUE, "    " );
	mprintf( YELLOW  ,  CONTINUE, "[z]" );
	mprintf( LIGHTGRAY, CONTINUE, " " );   
	mprintf( CYAN,      CONTINUE, "OTG :" );  
	mprintf( LIGHTGRAY, CONTINUE, " Bus request                " );

	mprintf( YELLOW  ,  CONTINUE, "[7]" );
	mprintf( LIGHTGRAY, CONTINUE, " " );   
	mprintf( CYAN,      CONTINUE, "OTG :" );  
	mprintf( LIGHTGRAY, CONTINUE, " String message receive\r\n" );


	mprintf( LIGHTGRAY, CONTINUE, "    " );
	mprintf( YELLOW  ,  CONTINUE, "[/]" );
	mprintf( LIGHTGRAY, CONTINUE, " " );   
	mprintf( CYAN,      CONTINUE, "OTG :" );  
	mprintf( LIGHTGRAY, CONTINUE, " V-bus drop                 " );

	mprintf( YELLOW  ,  CONTINUE, "[8]" );
	mprintf( LIGHTGRAY, CONTINUE, " " );   
	mprintf( CYAN,      CONTINUE, "OTG :" );  
	mprintf( LIGHTGRAY, CONTINUE, " Dummy data transfer\r\n" );


	mprintf( LIGHTGRAY, CONTINUE, "    " );
	mprintf( YELLOW  ,  CONTINUE, "[u]" );
	mprintf( LIGHTGRAY, CONTINUE, " " );   
	mprintf( CYAN,      CONTINUE, "OTG :" );  
	mprintf( LIGHTGRAY, CONTINUE, " Update executable binary   " );

	mprintf( YELLOW  ,  CONTINUE, "[9]" );
	mprintf( LIGHTGRAY, CONTINUE, " " );   
	mprintf( CYAN,      CONTINUE, "OTG :" );  
	mprintf( LIGHTGRAY, CONTINUE, " Play music on remote peer\r\n" );


	mprintf( LIGHTGRAY, CONTINUE, "    " );
	mprintf( YELLOW  ,  CONTINUE, "[A]" );
	mprintf( CYAN,      CONTINUE, " OTG :" );  
	mprintf( LIGHTGRAY, CONTINUE, " Remote audio data play\r\n" );

	mprintf( LIGHTGRAY, CONTINUE, "\r\n" );
}


void version_info( void )
{
	clrscr();
	
	mprintf( LIGHTGRAY, CONTINUE, "    Version info:\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "    ^^^^^^^^^^^^^\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "\r\n\r\n" );

	mprintf( LIGHTGRAY,     CONTINUE, "   " );
	mprintf( (GREEN << 4) | WHITE,     CONTINUE, " WASABI-" );
	mprintf( (GREEN << 4) | LIGHTRED,  CONTINUE, "Hot!" );
	mprintf( (GREEN << 4) | WHITE,     CONTINUE, " " );

	mprintf( LIGHTGRAY, CONTINUE, "   [%s]\r\n", VERSION_CODE_NAME );
	mprintf( LIGHTGRAY, CONTINUE, "    version %s ", VERSION_NUMBER );
	mprintf( LIGHTGRAY, CONTINUE, "(%s, %s)", __DATE__, __TIME__ );
	mprintf( LIGHTGRAY, CONTINUE, "\r\n" );
	mprintf( WHITE, CONTINUE, "                                                        OKANO, Akifumi         \r\n" );
	mprintf( WHITE, CONTINUE, "                                                        HIGASHIYAMA, Ken       \r\n" );
	mprintf( WHITE, CONTINUE, "                                                        HARASHIMA, Hisashige   \r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "                                                               +81-3-3740-4744 \r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "                                                     wired.support@philips.com \r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "                                         Application Lab., Mobile&Connectivity \r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "                                     Philips Semiconductors @ Tokyo  2001-2004 \r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "                              http://www.semiconductors.philips.com/buses/usb/ \r\n" );

}


void environment_info( void )
{
	clrscr();
	
	mprintf( LIGHTGRAY, CONTINUE, "    Environment info:\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "    ^^^^^^^^^^^^^^^^^\r\n" );

	mprintf( LIGHTGRAY, CONTINUE, "      Access            : addr=0x%04X irq(Hc/Dc)=%02u/%02u on %s-bus\r\n", gp_ISA_base_address, gp_Hc_IRQ_num, gp_Dc_IRQ_num, gp_is_PCI ? "PCI" : "ISA" );
	mprintf( LIGHTGRAY, CONTINUE, "      Enumeration mode  : speed=%s / beep=%s / warning=%s\r\n", gp_fast_enumeration ? "Fast  " : "Normal", gp_silent_enumeration ? "Silent" : "Normal", gp_warning_message ? "Enabled" : "Disabled" );
	
	if ( *gp_sing_file_strings[ 1 ].file_path_and_name == 0 )
	mprintf( LIGHTGRAY, CONTINUE, "      Music file        : \"%s\"\r\n", gp_sing_file_strings[ 0 ].file_path_and_name );
	else
	mprintf( LIGHTGRAY, CONTINUE, "      Music list file   : \"%s\"\r\n", gp_sing_list_file_str );
		
	mprintf( LIGHTGRAY, CONTINUE, "      Attenuation level : %ddB\r\n", audio_volume_value_set( GET_CURRENT_VOLUME_LEVEL ) * dB_STEP );

	mprintf( LIGHTGRAY, CONTINUE, "\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "      Printer file path : \"%s\"\r\n", gp_printer_default_file_path );
	mprintf( LIGHTGRAY, CONTINUE, "\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "      OTG peer id name  : \"%s\"\r\n", gp_id_string );
	mprintf( LIGHTGRAY, CONTINUE, "      ChargePump select : %s\r\n", gp_charge_pump_external ? "external" : "internal" );
	
	mprintf( LIGHTGRAY, CONTINUE, "\r\n\r\n" );
}


void test_info( void )
{
	char	*str[]	=	{
							"Philips Semiconductors ISP1362  USB single-chip Host/Device controller",
							"ISP1161 HC  test harness softwae project. Started in summer-2001. ",
							"1161_test_harness, Kenobi0, Kenobi2, Yebisu (Kenobi3)"
						};
	int		i;
	int		j;
	int		len;
	
	for ( i = 0; i < 3; i++ )
	{
		len		= strlen( str[ i ] );
	
		for ( j = 0; j < len; j++ )
		{
			mprintf( WHITE, CONTINUE, "%c", str[ i ][ j ] );
			wait_ms( 100L );
		}
		
		for ( j = len; j > 0; j-- )
		{
			gotoxy( j, wherey() );
			mprintf( BLACK, CONTINUE, " " );
			wait_ms( 100L );
		}
	}
}

//	##	version1.2c (from here)

void ui_over_current_detected_message( unsigned char port )
{
	mprintf( LIGHTRED, CONTINUE, "\r\n\r\n    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\r\n" );
	mprintf( LIGHTRED, CONTINUE,         "    !!    OverCurrent detected!    !!\r\n" );
	mprintf( LIGHTRED, CONTINUE,         "    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\r\n" );
	mprintf( LIGHTRED, CONTINUE,         "    @port" );
	mprintf( WHITE,    CONTINUE,         " %u   ", port + 1 );
	mprintf( LIGHTRED, CONTINUE,         "(\"%s\" detection)\r\n\r\n", (read_register16( Com16_HcHardwareConfiguration ) & 0x0400) ? "analog" : "digital" );
	
}


#ifdef	PER_PORT_POWER_SWITCHING
void turn_ON_OFF_vbus( void )
{
	unsigned long	port_stat[ 2 ];
	unsigned short	port[ 2 ]			= { Com32_HcRhPortStatus1, Com32_HcRhPortStatus2 };
	unsigned short	i;
	unsigned char	c;
	
	mprintf( WHITE, CONTINUE, "\r\n\r\n  Vbus control" );
	mprintf( LIGHTGRAY, CONTINUE, " on RootHub ports\r\n\r\n" );
	
	for ( i = 0; i < 2; i++ )
	{
		port_stat[ i ]	= ( read_register32( port[i] ) & 0x00000100 ) ? True : False;
		mprintf( LIGHTGRAY, CONTINUE, "    Vbus@port%u = ", i + 1 );
		mprintf( port_stat[ i ] ? LIGHTGREEN : LIGHTRED, CONTINUE, "%s\r\n", port_stat[ i ] ? "ON" : "OFF" );
	}

	mprintf( LIGHTGRAY, CONTINUE, "\r\n    press key" );
	mprintf( YELLOW, CONTINUE, "[1]" );
	mprintf( LIGHTGRAY, CONTINUE, " or " );
	mprintf( YELLOW, CONTINUE, "[2]" );
	mprintf( LIGHTGRAY, CONTINUE, " to toggle the state.\r\n" );
	mprintf( LIGHTGRAY, CONTINUE, "    press other key to cancel.\r\n" );
	
	c	= ui_key_wait() & 0xFF;
	
	if ( c == '1' )
		i	= 0;
	else if ( c == '2' )
		i	= 1;
	else
		return;

	mprintf( LIGHTGRAY, CONTINUE, "\r\n    Vbus@port%u state changed from ", i + 1 );
	mprintf( port_stat[ i ] ? LIGHTGREEN : LIGHTRED, CONTINUE, "%s", port_stat[ i ] ? "ON" : "OFF" );
	mprintf( LIGHTGRAY, CONTINUE, " to " );

	portctl_Vbus_control_for_port_1_or_2( port_stat[ i ] ? False : True, i + 1 );

	port_stat[ i ]	= ( read_register32( port[i] ) & 0x00000100 ) ? True : False;
	mprintf( port_stat[ i ] ? LIGHTGREEN : LIGHTRED, CONTINUE, "%s", port_stat[ i ] ? "ON" : "OFF" );
	mprintf( LIGHTGRAY, CONTINUE, ".\r\n\r\n" );
}
#endif	// PER_PORT_POWER_SWITCHING



void resume_trigger_service( unsigned char dummy_for_func_compatibility );
unsigned char	clk_ready;
unsigned char	rh_ev;

void suspend_test( void )
{
	unsigned short	hw_cnfg;
	unsigned short	int_en;

	mprintf( WHITE, CONTINUE, "\r\n\r\n  System SUSPEND test\r\n" );
	
	mprintf( LIGHTGRAY, CONTINUE, "    SUSPEND with X-tal clock OFF\r\n" );
	mprintf( LIGHTRED,  CONTINUE, "    Hit PC's keyboard or make root-hub event to RESUME...\r\n\r\n" );


	/********************************************************************/
	/*	Setup registers before go into SUSPEND                          */
	/********************************************************************/

	hw_cnfg		= read_register16( Com16_HcHardwareConfiguration );
	int_en		= read_register16( Com16_HcuPInterruptEnable );

#if 1
	write_register16( 0x62, read_register16( 0x62 ) & ~0x1 );

	write_register16( Com16_HcuPInterruptEnable, 0x0050 );
	write_register16( Com16_HcHardwareConfiguration, hw_cnfg | 0x0001 );
	
	write_register16( Com16_HcHardwareConfiguration, hw_cnfg | 0x4000 );

	clk_ready	= False;
	rh_ev		= False;
	
	/********************************************************************/
	/*	Install callback function to catch RESUME trigger as interrupt  */
	/********************************************************************/
	
	//
	//	Register a callback function. Called in ISR context
	//
	
	//isr_install_ClkReady_service_routine( resume_trigger_service );	//	To catch clock re-started
	isr_install_RH_event_service_routine( resume_trigger_service );		//	To resume by root-hub event

#endif
	

	/********************************************************************/
	/*	1st : Set DC SUSPEND                                            */
	/********************************************************************/

//#define FOR_LOGIC_ANALYZER_CAPTURE	//	With defining this keyword, the DC-SUSPEND will be 
										//	done immediately. This can supress the function call 
										//	overhead. In Turbo-C, this will make big difference 
										//	for timing monitoring.
#ifdef	FOR_LOGIC_ANALYZER_CAPTURE

	Comm_w16(W_Mode_Register, (Mode_Value | GOSUSP) );		//	Get into suspend
	Comm_w16(W_Mode_Register, Mode_Value );					//	Get into suspend
	
#else

	dc_set_dc_suspend();
	
#endif

	/********************************************************************/
	/*	2nd : Set HC SUSPEND                                            */
	/********************************************************************/

	write_register32( Com32_HcControl, (read_register32( Com32_HcControl ) & ~0xC0) | 0xC0 );


	/********************************************************************/
	/*	Now the chip is in SUSPEND and clock is turned OFF              */
	/*	                                                                */
	/*	  Monitor it at X'tal pin                                       */
	/*	                                                                */
	/*	  Wait PC's keyboard hit or root-hub event                      */
	/*	                                                                */
	/********************************************************************/


	while ( !kbhit() && !clk_ready && !rh_ev )
		;


	mprintf( LIGHTRED, CONTINUE, "    RESUME" );

	if ( !clk_ready && !rh_ev )
	{	
		getch();							//	if the RESUME was initiated by keyboard hit, 
											//	pop the character in the buffer to clear the key.
		read_register16( Com16_HcChipID );	//	Kick any register to wakeup = Asserting ChipSelect


		mprintf( LIGHTRED, CONTINUE, " by KB hit.\r\n\r\n" );
	}
	else
	{
		mprintf( LIGHTRED, CONTINUE, " by root-hub event.\r\n\r\n" );
	}

	
	delay( 2 );								//	Wait for PLL stabilized.
	
	write_register16( Com16_HcHardwareConfiguration, hw_cnfg );	//	Restoring register
	write_register16( Com16_HcuPInterruptEnable, int_en );		//	Restoring register
	
	delay( 1 );
	write_register32( Com32_HcControl, 0x0680 );
}


void resume_trigger_service( unsigned char cause )
{
	clk_ready	= (!cause) ? True : False;
	rh_ev		= cause;
	
	isr_install_ClkReady_service_routine( NULL );
	isr_install_RH_event_service_routine( NULL );
}

//	##	version1.2c (to here)


void ui_topology_view( device_instance *dvi_ptr, unsigned char depth, unsigned char bg_color  )
{
	unsigned char	hub_flag;
	unsigned char	num_of_device	= 0;
	int				i,
					j;
	
	bg_color	= 0;

	hub_flag	= (device_class_code( dvi_ptr ) == 0x09) ? 1 : 0;

	if ( dvi_ptr->address == 1 )
		mprintf( LIGHTGRAY | bg_color, CONTINUE, "    [ RootHub ]\r\n" );
	else
	{
		mprintf( LIGHTGRAY | bg_color, CONTINUE, "|---" );
		mprintf( hub_flag ? LIGHTGRAY | bg_color : WHITE | bg_color, CONTINUE, "[%s(%02d)]", hub_flag ? "Hub" : "Dev", dvi_ptr->address );
//		mprintf( hub_flag ? LIGHTGRAY | bg_color : WHITE | bg_color, CONTINUE, "[%s(%02d)]\r\n", hub_flag ? "Hub" : "Dev", dvi_ptr->address );
		
		{
			//	Class name
			unsigned char	cid;
			
			if ( !(cid	= devep_get_device_class_ID( dvi_ptr )) )
			{
				cid	= devep_get_interface_class_ID( dvi_ptr );
				
				if ( cid )
					mprintf( RED | bg_color, CONTINUE, "%s", gp_class_str[ cid ] );
			}
		}

		mprintf( LIGHTGRAY | bg_color, CONTINUE, "\r\n" );

	}
	if ( hub_flag )
	{
		for ( i = 0; i < 5; i++ )
		{
			if ( NULL != (hub_instance_ptr( dvi_ptr )->portctl_device_on_port)[ i ] )
			{
				for ( j = 0; j < depth; j++ )
					mprintf( LIGHTGRAY | bg_color, CONTINUE, (j == 0) ? "             " : "|          " );
					
				num_of_device++;

				ui_topology_view( (hub_instance_ptr( dvi_ptr )->portctl_device_on_port)[ i ], (depth + 1), bg_color );
			}
		}
	}
}


void ui_show_topology( void )
{
	device_instance		tmp_dvi;
	unsigned char		num_of_dev	= 0;
	unsigned char		bg_color	= 0;
	int					i;
	
//gotoxy( 1, 5 );

	tmp_dvi.address					= 1;
	tmp_dvi.class_instance_ptr		= &gp_root_hub_instance;
	device_class_code( &tmp_dvi )	= 0x09;
	
	bg_color	= GREEN << 4;
	bg_color	= 0;
	
	mprintf( WHITE | bg_color, CONTINUE, "\r\n\r\n* Topology view : " );
	mprintf( WHITE | bg_color, CONTINUE, "\r\n" );

	ui_topology_view( &tmp_dvi, 1, bg_color );
	
	mprintf( WHITE, CONTINUE, "\r\n" );

	bg_color	= BLUE << 4;
	bg_color	= 0;

	mprintf( WHITE     | bg_color, CONTINUE, "* Address usage " );
	mprintf( LIGHTGRAY | bg_color, CONTINUE, "(" );
	mprintf( WHITE     | bg_color, CONTINUE, "white" );
	mprintf( LIGHTGRAY | bg_color, CONTINUE, "=used, " );
	mprintf( LIGHTRED       | bg_color, CONTINUE, "red" );
	mprintf( LIGHTGRAY | bg_color, CONTINUE, "=unused) : \r\n     " );

	for ( i = 2; i < 20; i++ )
		mprintf( devep_find_device( i ) ? WHITE | bg_color : LIGHTRED | bg_color, CONTINUE, "  %d", i );

	for ( i = 2; i < MAX_DEVICE_NUM; i++ )
		if ( devep_find_device( i ) )
			num_of_dev++;

	mprintf( LIGHTGRAY | bg_color, CONTINUE, "\r\n    %d USB devices (incl. hubs) on the bus", num_of_dev );
	mprintf( LIGHTGRAY,            CONTINUE, "\r\n" );
}


/*********															*********/
/*																			*/
/*	Audio/Printer/Keyboard applet interface									*/
/*																			*/
/*		To use key input						 							*/
/*																			*/
/*********															*********/


char *ui_get_string_from_console( char *s, int length, unsigned char input_color, char *prompt_string, unsigned char prompt_color, char *suffix, char *preset_string, unsigned short *key_ptr )
{
//	a pointer "file_list" will gives you a warning at build time
//	it is reserved for future use, so please ignore it

	char			*cs_ptr;
	int				curs;
	int				key;
	int				i;
	
	if ( suffix == 0 )
		strcpy( suffix, "" );
	
//	strcpy( s, gp_printer_default_file_path );
	strcpy( s, preset_string );
	curs	= strlen( s );
	
	mprintf( prompt_color, CONTINUE, "\r%s", prompt_string );
	mprintf( input_color,  CONTINUE, "%s", s );

	while ( 0x0D != ((key	= ui_key_wait()) & 0xFF ))
	{	
		if ( (NULL != key_ptr) && !(key & 0xFF) )
		{
			if ( (key == 0x4800) || (key == 0x5000) )
			{
				*key_ptr	= key;
				return ( s );
			}
		}
		
		if ( key & 0xFF )
		{
			key		&= 0xFF;
			
			if ( isprint( key ) )
			{
				if ( curs < (length - 1) )
				{
					mprintf( input_color, CONTINUE, "%c", (char)key );
					*(s + curs++)	 = (char)key;
				}
				else
				{
					mprintf( LIGHTRED, CONTINUE, "!!" );
				}
			}
			else if ( 0x1B == key )		//	case of [ESC]
			{
				*s		= 0xFF;
				return ( s );
			}	
			else if ( 0x08 == key )
			{
				curs			-= (0 < curs) ? 1 : 0;
				*(s + curs)		 = 0;
				
				mprintf( prompt_color, CONTINUE, "\r%s", prompt_string );
				mprintf( input_color, CONTINUE, "%s  \r", s );
				
				mprintf( prompt_color, CONTINUE, "%s", prompt_string );
				mprintf( input_color, CONTINUE, "%s", s );
			}
			else
			{
			}
		}
		else
		{

			//
			//	Under construction
			//

			key		>>= 8;
			
			if ( (key != 0x48) && (key != 0x50) )
				continue;
		}
	}
	
	*(s + curs)		= 0;
	
	cs_ptr		= strrchr( s, '/' );
	cs_ptr		= cs_ptr ? cs_ptr : s;
	
	if ( !strchr( cs_ptr, '.' ) )
		strcat( s, suffix );

	return ( s );
}


void *ui_mmalloc( size_t s )
{
	void *p;
	
	p	= malloc( s + 0 );
	mprintf( LIGHTMAGENTA, CONTINUE, "malloc=%p, size=%d\r\n", p, s );

	return ( p );
}


void ui_ffree( void *p )
{
	mprintf( LIGHTMAGENTA, CONTINUE, "free=%p\r\n", p );
	free( p );
}




void ui_debug_marker( unsigned short v )
{
	write_register16( Com16_HcScratch, v );
}
